<?php
/**
 * Created by JetBrains PhpStorm.
 * User: leandroafonso
 * Date: 05/02/14
 * Time: 15:01
 * To change this template use File | Settings | File Templates.
 */
namespace Folha\Facade;

class WinHrm00009000{

    public static function gerarCnab(){
        set_time_limit(0);
        ini_set('memory_limit','2048M');

        $form = tk_get_all_fields();
		        
        try{
			// leonardocarvalho - 01/12/2014
            $cdbanco = tk_get_field_value('CDBANCO');

            //gabrielcapanema - 21/05/2015 : filtra por tipo vínculo CNAB
            $tpvinculo = tk_get_field_value('DSTIPOVINCULO');

            //Adaptação para os cnabs antigos (Brasil e santander)
            switch($cdbanco){ //Quando implemtado estes 2 bancos na classe Cnab240 este switch deve ser retirado mantendo o código abaixo
                case '001': //Banco do brasil selecionado
                case '033'; //Santander selecinado
                    $nrOrg = \Ambiente::getNrorg();
                    $cdOperador = \Ambiente::getCdOperador();
                    $parametro = new \Parametros($nrOrg, $cdOperador);
                    try {
                        $tpProcessamento = \Setforms2\Shared\Util\Util::replaceToken("COMPETENCIA_MENSAL");
                        $nrFormulario = \Setforms2\Shared\Util\Util::replaceToken("@tk_get_field_value('NRFORMCNAB')@");
                        $preparaCnab = new \PercorreCNAB($tpProcessamento, $nrFormulario, $parametro, $tpvinculo);
                        $preparaCnab->percorre();
                    } catch (\Exception $e) {
                        tk_warning("Não foi possível gerar o CNAB.");
                        tk_warning($e->getMessage());
                    }
                    break;
                case '237'; //Bradesco selecionado. Nova implementação.
					// leonardocarvalho - 01/12/2014
					$params = self::trataParametros($form);
                    $classe = '\Folha\Logic\Cnab240'.$cdbanco;
                    $cnab = new $classe($params);
                    //$cnab = new \Folha\Logic\Cnab240237($params); //usado apenas para debug
                    $cnab->setCaminhoRelativo('CNAB_files');
                    $cnab->prepara();
                    $cnab->geraCabecalho();
                    $cnab->geraRegistros();
                    $cnab->geraRodape();
                    tk_message('Arquivo '.$cnab->getNomeArquivoGerado().' gerado com sucesso!','success');
                    break;
                default: //Trata as classes de bancos ainda não criadas
                    tk_warning('Este banco ainda não está integrado ao sistema');
            }
            //fim da adaptação
        }catch(\Exception $e){
            tk_warning('Ao tentar gerar o CNAB ocorreu um erro: '.$e->getMessage());
        }

    }

    private static function trataParametros($params){
        $ret = array();
        foreach($params as $key => $value){
            $ret[$key] = $value[1];
        }
        unset($ret['_ID']);
        unset($ret['_STATE']);
        unset($ret['_CHECKED']);
        unset($ret['INFO']);
        unset($ret['_ACTIVE']);
        unset($ret['CDOPERULTATU']);
        unset($ret['NRORGULTATU']);
        unset($ret['CDOPERINCLUSAO']);
        unset($ret['DTINCLUSAO']);
        unset($ret['NRORGINCLUSAO']);
        unset($ret['DTULTATU']);
        return $ret;
    }

    public static function retrocederCnab(){
        //set_time_limit(0);
        //ini_set('memory_limit','2048M');

        $form = tk_get_all_fields();        
        try{
		   // leonardocarvalho - 01/12/2014
           $cdbanco = tk_get_field_value('CDBANCO');

            switch($cdbanco){
                case '001': //Banco do brasil selecionado
                case '033'; //Santander selecinado
                    $nrOrg = \Ambiente::getNrorg();
                    $cdOperador = \Ambiente::getCdOperador();
                    $parametro = new \Parametros($nrOrg, $cdOperador);
                    try {
                        $tpProcessamento = \Setforms2\Shared\Util\Util::replaceToken("RETROCESSO");
                        $nrFormulario = \Setforms2\Shared\Util\Util::replaceToken("@tk_get_field_value('NRFORMCNAB')@");
                        $preparaCnab = new \PercorreCNAB($tpProcessamento, $nrFormulario, $parametro);
                        $preparaCnab->percorre();
                    } catch (\Exception $e) {
                        tk_warning("Não foi possível gerar o CNAB.");
                        tk_warning($e->getMessage());
                    }
                    break;
                case '237': //Bradesco selecionado.
					// leonardocarvalho - 01/12/2014
					$params = self::trataParametros($form);
                    $classe = '\Folha\Logic\Cnab240'.$cdbanco;
                    $cnab = new $classe($params); //$cnab = new \Folha\Logic\Cnab240237($params);
                    $cnab->retrocede();
                    tk_warning('Magnético do CNAB retrocedido.');
                    break;
                default: //Trata as classes de bancos ainda não criadas
                    tk_warning('Este banco ainda não está integrado ao sistema');
            }
        }catch(\Exception $e){
            tk_warning('Ao tentar gerar o CNAB ocorreu um erro: '.$e->getMessage());
        }
    }
}