<?php
namespace Suprimentos\Repositories;

use Geral\Util\DateUtil;

class Coletapr extends \Doctrine\ORM\EntityRepository
{
    public function queryGetParam($cdfilial){
        try{
            $sql = "SELECT PARCMPSUP.CDFILIAL, PARCMPSUP.IDUTAPROVSOL, PARCMPSUP.CDGRUPPROD,
                      PARCMPSUP.CDSUBGRPROD, PARASUPRI.IDULTDESTSOL, PARASUPRI.IDEXIGAPRGERCMP, PARASUPRI.IDAPROVITMSOLGR
                 FROM PARCMPSUP, PARASUPRI, FILIAL
                WHERE PARCMPSUP.CDFILIAL = FILIAL.CDFILIAL
                  AND PARASUPRI.CDFILIAL = NVL(FILIAL.CDFILCENTCMP, FILIAL.CDFILIAL)
                  AND FILIAL.CDFILIAL = '$cdfilial'";
            return $this->getEntityManager()->getConnection()->fetchAll($sql);
        }
        catch(\Exception $e){
            throw $e;
        }
    }

    public function queryGetCdfilSoli($nrcompra){
        try{
            $sql = "SELECT LISTAGG(CDFILSOLI, '_') WITHIN GROUP (ORDER BY CDFILSOLI) AS CDFILSOLI
                      FROM(SELECT DISTINCT CDFILSOLI
                             FROM PRODCOMPRA
                            WHERE NRCOMPRA = '$nrcompra')";
            return $this->getEntityManager()->getConnection()->fetchAll($sql);
        }
        catch(\Exception $e){
            throw $e;
        }
    }



    public function queryGetCdfillanc($nrcompra){
        try{
            $sql = "SELECT LISTAGG(CDFILLAN, '_') WITHIN GROUP (ORDER BY CDFILLAN) AS CDFILLAN
                      FROM(SELECT DISTINCT CDFILLAN
                             FROM PRODCOMPRA
                            WHERE NRCOMPRA = '$nrcompra')";
            return $this->getEntityManager()->getConnection()->fetchAll($sql);
        }
        catch(\Exception $e){
            throw $e;
        }
    }

    public function queryDinamicForprcompra($campo, $key, $paramkey){
        try{
            $sql = "SELECT $campo
                      FROM FORPRCOMPRA
                     WHERE $key = '$paramkey'";
            return $this->getEntityManager()->getConnection()->fetchAll($sql);
        }
        catch(\Exception $e){
            throw $e;
        }
    }

    public function queryDinamicCompra($campo, $key, $paramkey){
        try{
            $sql = "SELECT $campo
                      FROM COMPRA
                     WHERE $key = '$paramkey'";
            return $this->getEntityManager()->getConnection()->fetchAll($sql);
        }
        catch(\Exception $e){
            throw $e;
        }
    }

    public function queryDinamicProdCompra($campo, $key, $paramkey){
        try{
            $sql = "SELECT $campo
                      FROM PRODCOMPRA
                     WHERE $key = '$paramkey'";
            return $this->getEntityManager()->getConnection()->fetchAll($sql);
        }
        catch(\Exception $e){
            throw $e;
        }
    }

    /*
     * $joker -> 'DISTINCT' ou 'CDFILIAL,'(VIRGULA OBRIGATÓRIO)
     * $listafilsoli -> 'CDFILIAL_CDFILIAL_CDFILIAL'
     */
    public function queryCentralDeCompras($joker,$listafilsoli){
        try{
            $sql = "SELECT $joker NVL(CDFILCENTCMP,CDFILIAL) CDFILCENTCMP
                      FROM  FILIAL
                     WHERE  INSTR('$listafilsoli' , CDFILIAL) > 0";
            return $this->getEntityManager()->getConnection()->fetchAll($sql);
        }
        catch(\Exception $e){
            throw $e;
        }
    }

    public function queryDescontoForn($cdforneced){
        try{
            $sql = "SELECT DECODE(FORNECEDOR.IDTPDESCFORN, 'C', NVL(FORNECEDOR.VRPEDESCFORN, 0),0) AS VRPEDESCFORN
                      FROM FORNECEDOR
                     WHERE FORNECEDOR.CDFORNECED = '$cdforneced'";
            return $this->getEntityManager()->getConnection()->fetchAll($sql);
        }
        catch(\Exception $e){
            throw $e;
        }
    }

    public function queryExistPedCol($cdregiao, $cdforneced, $dtini, $dtfin){
        try{
            $sql = "SELECT MAX(CDREGIAO) CDREGIAO
                      FROM PEDCOLETA
                     WHERE CDREGIAO    = '$cdregiao'
                       AND CDFORNECED  = '$cdforneced'
                       AND DTINIPERCOT = '$dtini'
                       AND DTFINPERCOT = '$dtfin'";
            return $this->getEntityManager()->getConnection()->fetchAll($sql);
        }
        catch(\Exception $e){
            throw $e;
        }
    }

    public function queryGetFiltroCompra($cdforneced, $Tcdforneced, $nrcompra){
        try{
            $sql = "SELECT DISTINCT
                          FORNECEDOR.NMFANTFORN,
                          FORNECEDOR.CDFORNECED,
                          NVL(FORNECEDOR.DSEMAILPEDCOLFO, FORNECEDOR.DSEMAILCOT) DSEMAILCOT,
                          REGIAO.NMREGIAO,
                          REGIAO.CDREGIAO,
                          OPERADOR.NMOPERADOR,
                          OPERADOR.CDOPERADOR,
                          NVL(FORNECEDOR.DSMAILPEDCOLCOP, FORNECEDOR.DSMAILCOTCOP) DSMAILCOTCOP
                        FROM
                          PRODCOMPRA,
                          COMPRA,
                          (SELECT
                              NMFANTFORN,
                              CDFORNECED,
                              DSEMAILCOT,
                              DSMAILCOTCOP,
                              DSEMAILPEDCOLFO,
                              DSMAILPEDCOLCOP
                           FROM
                              FORNECEDOR
                           WHERE
                              INSTR('$cdforneced' , CDFORNECED) > 0 OR '$Tcdforneced'  = 'T' )FORNECEDOR,
                          OPERADOR,
                          REGIAO, FILIAL, FORPRCOMPRA
                        WHERE
                          PRODCOMPRA.CDFILSOLI = FILIAL.CDFILIAL AND
                          FILIAL.CDREGIAO = REGIAO.CDREGIAO AND
                          PRODCOMPRA.NRCOMPRA = COMPRA.NRCOMPRA AND
                          PRODCOMPRA.NRCOMPRA = '$nrcompra' AND
                          COMPRA.CDCOMPRADOR   = OPERADOR.CDOPERADOR   AND
                          FORPRCOMPRA.NRCOMPRA = PRODCOMPRA.NRCOMPRA AND
                          FORPRCOMPRA.CDFORNECED = FORNECEDOR.CDFORNECED AND
                          NOT EXISTS (SELECT 1
                                        FROM REFOREG
                                       WHERE REFOREG.CDREGIAO   = REGIAO.CDREGIAO
                                         AND REFOREG.CDFORNECED = FORNECEDOR.CDFORNECED)
                        ORDER BY
                          OPERADOR.NMOPERADOR,
                          FORNECEDOR.NMFANTFORN,
                          REGIAO.NMREGIAO";
            return $this->getEntityManager()->getConnection()->fetchAll($sql);
        }
        catch(\Exception $e){
            throw $e;
        }
    }

    public function queryGetParamCurvaABCAF(){
        try{
            $sql = "SELECT TO_DATE('01/'||TO_CHAR(ADD_MONTHS(SYSDATE, -1), 'MM/YYYY'), 'DD/MM/YYYY') AS DTINICIAL,
                           LAST_DAY(ADD_MONTHS(SYSDATE, -1)),
                           IDSISDOS
                      FROM PARAMGERAL";
            return $this->getEntityManager()->getConnection()->fetchAll($sql);
        }
        catch(\Exception $e){
            throw $e;
        }
    }

    public function queryGetProdutoCentCmp($nrcompra,$cdcentcmp,$cdforneced){
        try{
            $sql = "SELECT PRODCOMPRA.CDPRODUTO,PRODCOMPRA.CDFILSOLI
                      FROM PRODCOMPRA,FILIAL,PRODFORNCOMP
                     WHERE PRODCOMPRA.CDFILSOLI = FILIAL.CDFILIAL
                       AND PRODFORNCOMP.CDPRODCOMPL = PRODCOMPRA.CDPRODUTO
                       AND NVL(FILIAL.CDFILCENTCMP,FILIAL.CDFILIAL) = '$cdcentcmp'
                      AND PRODCOMPRA.NRCOMPRA = '$nrcompra'
                      AND PRODFORNCOMP.CDFORNECED = '$cdforneced'
                      AND NOT EXISTS (SELECT *
                                        FROM REFORFIL
                                       WHERE REFORFIL.CDFILIAL =PRODCOMPRA.CDFILSOLI
                                         AND PRODFORNCOMP.CDFORNECED = REFORFIL.CDFORNECED)";
            return $this->getEntityManager()->getConnection()->fetchAll($sql);
        }
        catch(\Exception $e){
            throw $e;
        }
    }

    public function queryParamMercadum(){
        try{
            $sql = "SELECT IDUTINTMERCADUM FROM PARAMGERAL";
            return $this->getEntityManager()->getConnection()->fetchAll($sql);
        }
        catch(\Exception $e){
            throw $e;
        }
    }

    public function queryGetReEnvioEmail(){
        try{
            $sql = "SELECT ' ' AS IDMARCADO,
                       REENVIOMAILPCOL.NRSEQREENVIOCOL,
                       REENVIOMAILPCOL.CDFILIAL,
                       REENVIOMAILPCOL.NRPEDIDOCOL,
                       REENVIOMAILPCOL.CDFORNECED,
                       REENVIOMAILPCOL.IDTIPOEMAILPCOL,
                       TO_CHAR(PEDCOLGERAL.DTPEDCOLGERAL) DTPEDCOLGERAL,
                       TO_CHAR(REENVIOMAILPCOL.DSASSUNTOPEDCOL) DSASSUNTOPEDCOL,
                       TO_CHAR(REENVIOMAILPCOL.DSMENSPEDCOL) DSMENSPEDCOL,
                       NVL(REENVIOMAILPCOL.DSEMAILPEDCOL, NVL(FORNECEDOR.DSEMAILPEDCOLFO, FORNECEDOR.DSEMAILCOT)) DSEMAILPEDCOL,
                       TO_CHAR(PEDCOLGERAL.DTINIPERGERAL) DTINIPERGERAL,
                       TO_CHAR(PEDCOLGERAL.DTFINPERGERAL) DTFINPERGERAL,
                       OPERADOR.CDOPERADOR,
                       OPERADOR.NMOPERADOR,
                       FORNECEDOR.NMFANTFORN,
                       TO_CHAR(NVL(FORNECEDOR.DSMAILPEDCOLCOP, FORNECEDOR.DSMAILCOTCOP)) DSMAILCOTCOP,
                       PEDCOLGERAL.CDOPERLANC
                    FROM REENVIOMAILPCOL, FORNECEDOR, OPERADOR, PEDCOLGERAL
                    WHERE REENVIOMAILPCOL.CDFORNECED = FORNECEDOR.CDFORNECED
                      AND REENVIOMAILPCOL.CDFILIAL = PEDCOLGERAL.CDFILIAL
                      AND REENVIOMAILPCOL.NRPEDIDOCOL = PEDCOLGERAL.NRPEDIDOCOL
                      AND OPERADOR.CDOPERADOR = PEDCOLGERAL.CDOPERADOR
                      AND PEDCOLGERAL.DTEXPIRAPEDCOL > SYSDATE
                    ORDER BY PEDCOLGERAL.DTINIPERGERAL DESC";
            return $this->getEntityManager()->getConnection()->fetchAll($sql);
        }
        catch(\Exception $e){
            throw $e;
        }
    }
    public function queryGetFornCentCmp($cdcentcmp,$cdforneced,$nrcompra){
        try{
            $sql = "SELECT FORPRCOMPRA.NRCOMPRA,NVL(FILIAL.CDFILCENTCMP,FILIAL.CDFILIAL) AS CDFILCENTCMP, FILIAL.CDFILIAL,FORPRCOMPRA.CDFORNECED
                      FROM FILIAL, FORPRCOMPRA
                     WHERE FILIAL.CDFILIAL IN(SELECT CT.CDFILIAL
                                        FROM FILIAL CT
                                       WHERE NVL(CT.CDFILCENTCMP,CT.CDFILIAL) = '$cdcentcmp')                                AND NOT EXISTS (SELECT CDFILIAL
                                         FROM REFORFIL R
                                        WHERE R.CDFILIAL   = FILIAL.CDFILIAL
                                AND R.CDFORNECED = FORPRCOMPRA.CDFORNECED)
                       AND FORPRCOMPRA.CDFORNECED = '$cdforneced'
                                AND FORPRCOMPRA.NRCOMPRA = '$nrcompra'";
                return $this->getEntityManager()->getConnection()->fetchAll($sql);
        }catch(\Exception $e){

        }
    }
    public function queryGetCompra($idsituenvfor, $idsitucoleta, $nrcompra, $idsitucompra, $cdempresa, $cdresponsavel, $cdcomprador, $cdgerente, $dtinicompra,$dtfincompra){
        try{
            $sql = "SELECT DISTINCT
                   COMPRA.NRCOMPRA,
                   COMPRA.DSCOMPRA,
                   COMPRA.DTENTRCMPINI,
                   COMPRA.DTENTRCMPFIN,
                   COMPRA.CDEMPRESA,
                   EMPRESA.NMEMPRESA,
                   COMPRA.CDTPCTPAGAR,
                   TIPOCTPAGAR.DSTPCTPAGAR,
                   COMPRA.CDOPERADOR,
                   OPERADOR.NMOPERADOR,
                   COMPRA.CDCOMPRADOR,
                   OPERCOMP.NMOPERADOR AS NMOPERCOMP,
                   COMPRA.IDSITUCOMPRA,
                   FORSELEC.QTTOTFORN,
                   FORNENV.QTFORNENV,
                   FORNCOT.QTFORNCOT
                FROM
                   COMPRA,
                   OPERADOR,
                   COMPRADOR,
                   OPERADOR OPERCOMP,
                   EMPRESA,
                   TIPOCTPAGAR,
                   GERENTE,
                   GERECOMP,
                   (SELECT NRCOMPRA, COUNT(DISTINCT CDFORNECED) AS  QTTOTFORN
                      FROM FORPRCOMPRA
                     GROUP BY NRCOMPRA) FORSELEC,
                   (SELECT NRCOMPRA, COUNT(DISTINCT CDFORNECED) QTFORNENV
                      FROM FORPRCOMPRA
                     WHERE IDSITUENVFOR = '$idsituenvfor'
                     GROUP BY NRCOMPRA) FORNENV,
                   (SELECT COLETAPR.NRCOMPRA, COUNT(DISTINCT ITEMCOLE.CDFORNECED) QTFORNCOT, COLETAPR.DTINIVALCOL, COLETAPR.DTFINVALCOL
                      FROM COLETAPR, ITEMCOLE, FORPRCOMPRA
                     WHERE COLETAPR.NRCOLEPRECO = ITEMCOLE.NRCOLEPRECO AND
                           COLETAPR.CDFILIAL = ITEMCOLE.CDFILIAL AND
                           NVL(COLETAPR.IDSITUCOLETA, '$idsitucoleta') = '$idsitucoleta'       AND
                           FORPRCOMPRA.CDFORNECED = ITEMCOLE.CDFORNECED AND
                           FORPRCOMPRA.NRCOMPRA = COLETAPR.NRCOMPRA AND
                           COLETAPR.NRCOMPRA IS NOT NULL            AND
                           NVL(ITEMCOLE.VRPRECUNIITM, 0) > 0
                     GROUP BY COLETAPR.NRCOMPRA, COLETAPR.DTINIVALCOL, COLETAPR.DTFINVALCOL) FORNCOT
                WHERE ((INSTR('$nrcompra' , COMPRA.NRCOMPRA) <> 0) OR ('$nrcompra'  = '$nrcompra'))
                  AND ((INSTR('$idsitucompra' , COMPRA.IDSITUCOMPRA) <> 0) OR ('$idsitucompra'  = '$idsitucompra'))
                  AND ((INSTR('$cdempresa' , COMPRA.CDEMPRESA) <> 0)     OR ('$cdempresa'  = '$cdempresa'))
                  AND ((INSTR('$cdresponsavel' , COMPRA.CDOPERADOR) <> 0)   OR ('$cdresponsavel'  = '$cdresponsavel'))
                  AND ((INSTR('$cdcomprador' , COMPRA.CDCOMPRADOR) <> 0) OR ('$cdcomprador'  = '$cdcomprador'))
                  AND ((INSTR('$cdgerente' , GERENTE.CDOPERADOR) <> 0)     OR ('$cdgerente'  = '$cdgerente'))
                  AND ((COMPRA.DTENTRCMPINI >= '$dtinicompra'  AND COMPRA.DTENTRCMPFIN <= '$dtfincompra' ) OR ('T' = 'T'))
                  AND GERENTE.CDOPERADOR     = GERECOMP.CDOPERGERE
                  AND COMPRA.CDCOMPRADOR     = GERECOMP.CDOPERCOMP
                  AND COMPRA.CDOPERADOR      = OPERADOR.CDOPERADOR
                  AND OPERCOMP.CDOPERADOR    = COMPRADOR.CDOPERADOR
                  AND COMPRA.CDCOMPRADOR     = COMPRADOR.CDOPERADOR
                  AND COMPRA.CDTPCTPAGAR     = TIPOCTPAGAR.CDTPCTPAGAR(+)
                  AND COMPRA.CDEMPRESA       = EMPRESA.CDEMPRESA
                  AND FORSELEC.NRCOMPRA(+)   = COMPRA.NRCOMPRA
                  AND FORNENV.NRCOMPRA(+)    = COMPRA.NRCOMPRA
                  AND FORNCOT.NRCOMPRA(+)    = COMPRA.NRCOMPRA
                  AND FORNCOT.DTINIVALCOL(+) = COMPRA.DTENTRCMPINI
                  AND FORNCOT.DTFINVALCOL(+) = COMPRA.DTENTRCMPFIN
                ORDER BY COMPRA.NRCOMPRA";
            return $this->getEntityManager()->getConnection()->fetchAll($sql);
        }
        catch(\Exception $e){
            throw $e;
        }
    }

    public function queryGetPedColeta($dtini, $dtfin, $cdprodini, $cdprodfin, $nrcompra, $cdforneced, $Tcdforneced, $cdmarca, $Tcdmarca){
        try{
            $sql = "SELECT DISTINCT
                           CDFORNECED,
                           IDTPIJURFORN,
                           NRINSJURFORN,
                           NMRAZSOCFORN,
                           IDTPFRETFORN,
                           NMREGIAO,
                           CDMARCA,
                           CDPRODESTO,
                           CDOPERADOR,
                           CDARVPROD,
                           SGUNIDADE,
                           NMPRODUTO,
                           NMFANTFORN,
                           QTACOMPRAR,
                           CDREGIAO,
                           CDPRODUTO,
                           NMOPERADOR,
                           NMMARCA,
                           CDMARCAPADR,
                           NRCOMPRA
                    FROM (SELECT FORNECEDOR.CDFORNECED,
                          FORNECEDOR.IDTPIJURFORN,
                          FORNECEDOR.NRINSJURFORN,
                          FORNECEDOR.NMRAZSOCFORN,
                          FORNECEDOR.IDTPFRETFORN,
                          REGIAO.NMREGIAO,
                          MARCA.CDMARCA,
                          PRODUTO.CDPRODESTO,
                          OPERADOR.CDOPERADOR,
                          PRODUTO.CDARVPROD,
                          PRODUTO.SGUNIDADE,
                          PRODUTO.NMPRODUTO,
                          FORNECEDOR.NMFANTFORN,
                          NVL(PRODACOMPRAR.QTACOMPRAR, 0) AS QTACOMPRAR,
                          REGIAO.CDREGIAO,
                          PRODUTO.CDPRODUTO,
                          OPERADOR.NMOPERADOR,
                          MARCA.NMMARCA,
                          MARCA.CDMARCA AS CDMARCAPADR,
                          PRODCOMPRA.NRCOMPRA
                       FROM PARASUPRI, COMPRA, PRODCOMPRA, FORPRCOMPRA, PRODUTO, MARCPRODCOMP, FILIAL FILI,
                            (SELECT COMP.CDREGIAO, COMP.CDPRODUTO, ROUND((COMP.QTDECOMP-NVL(JACOMP.QTDECOMP,0)) / COMP.VRFATOCONV, 5) AS QTACOMPRAR
                               FROM (SELECT FILIAL.CDREGIAO, PRODUTO.CDPRODESTO, PRODUTO.CDPRODUTO, PRODUTO.VRFATOCONV, SUM(ITEMSOLI.QTSOLIPROD*PRODUTO.VRFATOCONV) AS QTDECOMP
                                       FROM FILIAL, PRODUTO, PRODCOMPRA, REGIAO, ITEMSOLI
                                      WHERE (PRODCOMPRA.CDFILSOLI = FILIAL.CDFILIAL)
                                        AND (FILIAL.CDREGIAO = REGIAO.CDREGIAO)
                                        AND (PRODCOMPRA.CDPRODUTO = PRODUTO.CDPRODUTO)
                                        AND (PRODCOMPRA.DTPROGENTR BETWEEN '$dtini'  AND '$dtfin')
                                        AND (PRODUTO.CDARVPROD BETWEEN '$cdprodini'  AND '$cdprodfin')
                                        AND (PRODCOMPRA.NRCOMPRA = '$nrcompra')
                                        AND (PRODCOMPRA.CDFILSOLI = ITEMSOLI.CDFILSOLI)
                                        AND (PRODCOMPRA.CDFILLAN = ITEMSOLI.CDFILLAN)
                                        AND (PRODCOMPRA.NRSOLICMP = ITEMSOLI.NRSOLICMP)
                                        AND (PRODCOMPRA.DTPROGENTR = ITEMSOLI.DTPROGENTR)
                                        AND (PRODCOMPRA.CDPRODUTO = ITEMSOLI.CDPRODUTO)
                                      GROUP BY FILIAL.CDREGIAO, PRODUTO.CDPRODESTO, PRODUTO.CDPRODUTO, PRODUTO.VRFATOCONV) COMP,
                                    (SELECT FILIAL.CDREGIAO, PRODUTO.CDPRODESTO, SUM(ITEMAUTF.QTPROGENTAF*PRODUTO.VRFATOCONV) AS QTDECOMP
                                       FROM ITEMAUTF, AUTOFORNE, FILIAL, PRODUTO, PRODCOMPRA, REGIAO
                                      WHERE (AUTOFORNE.CDFILDEST = ITEMAUTF.CDFILDEST)
                                        AND (AUTOFORNE.CDFILLANC = ITEMAUTF.CDFILLANC)
                                        AND (AUTOFORNE.NRAUTOFORN = ITEMAUTF.NRAUTOFORN)
                                        AND (AUTOFORNE.CDFILDEST = FILIAL.CDFILIAL)
                                        AND (ITEMAUTF.CDPRODUTO = PRODUTO.CDPRODUTO)
                                        AND (PRODCOMPRA.CDPRODUTO = PRODUTO.CDPRODUTO)
                                        AND (PRODCOMPRA.CDFILSOLI = FILIAL.CDFILIAL)
                                        AND (ITEMAUTF.DTENTRITMSOL BETWEEN '$dtini'  AND '$dtfin')
                                        AND (FILIAL.CDREGIAO = REGIAO.CDREGIAO)
                                        AND (AUTOFORNE.IDSITUATUAAF IS NULL)
                                        AND (AUTOFORNE.IDAFFORALIM = 'N')
                                        AND (AUTOFORNE.IDAUTOFORNEX = 'N')
                                        AND NVL(AUTOFORNE.IDBAIXAAF, '0') <> '5'
                                      GROUP BY FILIAL.CDREGIAO, PRODUTO.CDPRODESTO) JACOMP
                              WHERE COMP.CDREGIAO = JACOMP.CDREGIAO (+)
                                AND COMP.CDPRODESTO = JACOMP.CDPRODESTO (+)
                                AND ROUND((COMP.QTDECOMP-NVL(JACOMP.QTDECOMP,0)) / COMP.VRFATOCONV, 5) > 0) PRODACOMPRAR,
                            (SELECT CDFORNECED, IDTPIJURFORN, NRINSJURFORN, NMRAZSOCFORN, NMFANTFORN, IDTPFRETFORN
                               FROM FORNECEDOR
                              WHERE INSTR('$cdforneced' , CDFORNECED) <> 0 OR '$Tcdforneced'  = 'T' )FORNECEDOR,
                            (SELECT CDMARCA, NMMARCA, IDMARCAATIVA
                               FROM MARCA
                              WHERE INSTR('$cdmarca', CDMARCA) <> 0 OR '$Tcdmarca' = 'T') MARCA,
                            REGIAO,
                            OPERADOR
                       WHERE (FILI.CDFILIAL = PRODCOMPRA.CDFILSOLI)
                         AND (PARASUPRI.CDFILIAL = NVL(FILI.CDFILCENTCMP, FILI.CDFILIAL))
                         AND (FILI.CDREGIAO = REGIAO.CDREGIAO)
                         AND (NVL(PARASUPRI.IDCONSPRSOL, 'N') <> 'S')
                         AND (COMPRA.NRCOMPRA = '$nrcompra')
                         AND (PRODUTO.CDARVPROD BETWEEN '$cdprodini'  AND '$cdprodfin')
                         AND (COMPRA.CDCOMPRADOR  = OPERADOR.CDOPERADOR)
                         AND (COMPRA.NRCOMPRA = PRODCOMPRA.NRCOMPRA)
                         AND (PRODCOMPRA.CDPRODUTO = PRODACOMPRAR.CDPRODUTO(+))
                         AND (PRODCOMPRA.CDPRODUTO  = PRODUTO.CDPRODUTO)
                         AND (FORPRCOMPRA.CDFORNECED = FORNECEDOR.CDFORNECED)
                         AND (PRODCOMPRA.CDPRODUTO  = MARCPRODCOMP.CDPRMARCOMPL)
                         AND (MARCPRODCOMP.CDMARCA = MARCA.CDMARCA)
                         AND (MARCA.IDMARCAATIVA       = 'A'
                         AND (FILI.IDFUNCAOFILI IS NULL)
                         AND (FORPRCOMPRA.NRCOMPRA = COMPRA.NRCOMPRA)

                       UNION ALL

                       SELECT FORNECEDOR.CDFORNECED,
                          FORNECEDOR.IDTPIJURFORN,
                          FORNECEDOR.NRINSJURFORN,
                          FORNECEDOR.NMRAZSOCFORN,
                          FORNECEDOR.IDTPFRETFORN,
                          REGIAO.NMREGIAO,
                          MARCA.CDMARCA,
                          PRODUTO.CDPRODESTO,
                          OPERADOR.CDOPERADOR,
                          PRODUTO.CDARVPROD,
                          PRODUTO.SGUNIDADE,
                          PRODUTO.NMPRODUTO,
                          FORNECEDOR.NMFANTFORN,
                          NVL(PRODACOMPRAR.QTACOMPRAR, 0) AS QTACOMPRAR,
                          REGIAO.CDREGIAO,
                          PRODUTO.CDPRODUTO,
                          OPERADOR.NMOPERADOR,
                          MARCA.NMMARCA,
                          MARCA.CDMARCA AS CDMARCAPADR,
                          PRODCOMPRA.NRCOMPRA
                       FROM PARASUPRI, COMPRA, PRODCOMPRA, FORPRCOMPRA, PRODUTO, MARCPRODCOMP,
                            (SELECT COMP.CDREGIAO, COMP.CDPRODUTO, ROUND(COMP.QTDECOMP-NVL(JACOMP.QTDECOMP/COMP.VRFATOCONV,0), 5) AS QTACOMPRAR
                               FROM (SELECT FILIAL.CDREGIAO, ESTOQUE.CDPRODESTO, ESTOQUE.CDPRODUTO, ESTOQUE.VRFATOCONV, SUM(ITEMSOLI.QTSOLIPROD*PRODUTO.VRFATOCONV/ESTOQUE.VRFATOCONV) AS QTDECOMP
                                       FROM PRODUTO ESTOQUE,  FILIAL, PRODUTO, PRODCOMPRA, REGIAO, ITEMSOLI
                                      WHERE (PRODCOMPRA.CDFILSOLI = FILIAL.CDFILIAL)
                                        AND (PRODCOMPRA.DTPROGENTR BETWEEN '$dtini'  AND '$dtfin')
                                        AND (PRODUTO.CDARVPROD BETWEEN'$cdprodini'  AND '$cdprodfin')
                                        AND (PRODCOMPRA.CDPRODUTO = PRODUTO.CDPRODUTO)
                                        AND (PRODUTO.CDPRODESTO = ESTOQUE.CDPRODESTO)
                                        AND (FILIAL.CDREGIAO = REGIAO.CDREGIAO)
                                        AND (PRODCOMPRA.CDFILSOLI = ITEMSOLI.CDFILSOLI
                                        AND (PRODCOMPRA.CDFILLAN = ITEMSOLI.CDFILLAN)
                                        AND (PRODCOMPRA.NRSOLICMP = ITEMSOLI.NRSOLICMP)
                                        AND (PRODCOMPRA.DTPROGENTR = ITEMSOLI.DTPROGENTR)
                                        AND (PRODCOMPRA.CDPRODUTO = ITEMSOLI.CDPRODUTO)
                                      GROUP BY FILIAL.CDREGIAO, ESTOQUE.CDPRODESTO, ESTOQUE.CDPRODUTO, ESTOQUE.VRFATOCONV) COMP,
                                    (SELECT FILIAL.CDREGIAO, PRODUTO.CDPRODESTO, SUM(ITEMAUTF.QTPROGENTAF*PRODUTO.VRFATOCONV) AS QTDECOMP
                                       FROM ITEMAUTF, AUTOFORNE, FILIAL, PRODUTO, REGIAO
                                      WHERE (AUTOFORNE.CDFILDEST = ITEMAUTF.CDFILDEST)
                                        AND (AUTOFORNE.CDFILLANC = ITEMAUTF.CDFILLANC)
                                        AND (AUTOFORNE.NRAUTOFORN = ITEMAUTF.NRAUTOFORN)
                                        AND (AUTOFORNE.CDFILDEST = FILIAL.CDFILIAL)
                                        AND (ITEMAUTF.DTENTRITMSOL BETWEEN '$dtini'  AND '$dtfin')
                                        AND (ITEMAUTF.CDPRODUTO = PRODUTO.CDPRODUTO)
                                        AND (AUTOFORNE.CDFILDEST = FILIAL.CDFILIAL)
                                        AND (FILIAL.CDREGIAO = REGIAO.CDREGIAO)
                                        AND (AUTOFORNE.IDSITUATUAAF IS NULL)
                                        AND (AUTOFORNE.IDAFFORALIM = 'N')
                                        AND (AUTOFORNE.IDAUTOFORNEX = 'N')
                                        AND NVL(AUTOFORNE.IDBAIXAAF, '0') <> '5'
                                      GROUP BY FILIAL.CDREGIAO, PRODUTO.CDPRODESTO) JACOMP
                              WHERE COMP.CDREGIAO = JACOMP.CDREGIAO (+)
                                AND COMP.CDPRODESTO = JACOMP.CDPRODESTO (+)
                                AND COMP.QTDECOMP-NVL(JACOMP.QTDECOMP/COMP.VRFATOCONV,0) > 0)PRODACOMPRAR,
                              REGIAO,
                              FILIAL,
                              OPERADOR,
                              (SELECT CDMARCA, NMMARCA, IDMARCAATIVA
                                 FROM MARCA
                                WHERE INSTR('$cdmarca', CDMARCA) <> 0 OR '$Tcdmarca' = 'T') MARCA,
                              (SELECT CDFORNECED, IDTPIJURFORN, NRINSJURFORN, NMRAZSOCFORN, NMFANTFORN, IDTPFRETFORN
                                 FROM FORNECEDOR
                                WHERE INSTR('$cdforneced' , CDFORNECED) <> 0 OR '$Tcdforneced'  = 'T' )FORNECEDOR,
                              (SELECT PARAMPRODSUP.CDREGIAO, PARAMPRODSUP.CDPRODUTO
                                 FROM PARAMPRODSUP, FILIAL, PRODCOMPRA
                                WHERE (PRODCOMPRA.CDFILSOLI = FILIAL.CDFILIAL)
                                  AND (FILIAL.IDFUNCAOFILI = 'C')
                                  AND (FILIAL.CDFILIAL = PARAMPRODSUP.CDFILICTRL)
                                  AND (PARAMPRODSUP.IDFILINEGCOR = 'S')
                                UNION ALL
                               SELECT PARAMPRODSUP.CDREGIAO, PARAMPRODSUP.CDPRODUTO
                                 FROM PARAMPRODSUP, FILIAL, PRODCOMPRA
                                WHERE (PRODCOMPRA.CDFILSOLI = FILIAL.CDFILIAL)
                                  AND (FILIAL.IDFUNCAOFILI = 'R')
                                  AND (FILIAL.CDFILIAL = PARAMPRODSUP.CDFILICTRL)
                                  AND (PARAMPRODSUP.IDFILINEGREG = 'S')) PARAMPRODSUP
                       WHERE (COMPRA.NRCOMPRA = '$nrcompra')
                         AND (FILIAL.CDFILIAL = PRODCOMPRA.CDFILSOLI)
                         AND (PARASUPRI.CDFILIAL = NVL(FILIAL.CDFILCENTCMP, FILIAL.CDFILIAL))
                         AND (NVL(PARASUPRI.IDCONSPRSOL, 'N') <> 'S')
                         AND (COMPRA.NRCOMPRA = PRODCOMPRA.NRCOMPRA)
                         AND (PRODCOMPRA.NRCOMPRA = FORPRCOMPRA.NRCOMPRA)
                         AND (COMPRA.CDCOMPRADOR  = OPERADOR.CDOPERADOR)
                         AND (PRODCOMPRA.CDFILSOLI = FILIAL.CDFILIAL)
                         AND (FILIAL.CDREGIAO = REGIAO.CDREGIAO)
                         AND (PRODUTO.CDARVPROD BETWEEN '$cdprodini'  AND '$cdprodfin')
                         AND (PRODCOMPRA.CDPRODUTO = PRODACOMPRAR.CDPRODUTO(+))
                         AND (PRODCOMPRA.CDPRODUTO  = PRODUTO.CDPRODUTO)
                         AND (FORPRCOMPRA.CDFORNECED = FORNECEDOR.CDFORNECED)
                         AND (PRODCOMPRA.CDPRODUTO  = MARCPRODCOMP.CDPRMARCOMPL)
                         AND (MARCPRODCOMP.CDMARCA = MARCA.CDMARCA)
                         AND (MARCA.IDMARCAATIVA       = 'A')
                         AND (PARAMPRODSUP.CDPRODUTO = PRODCOMPRA.CDPRODUTO)
                       /*################################## IDCONSPRSOL DA PARASUPRI #############################################*/
                       UNION ALL
                       SELECT FORNECEDOR.CDFORNECED,
                              FORNECEDOR.IDTPIJURFORN,
                              FORNECEDOR.NRINSJURFORN,
                              FORNECEDOR.NMRAZSOCFORN,
                              FORNECEDOR.IDTPFRETFORN,
                              REGIAO.NMREGIAO,
                              MARCA.CDMARCA,
                              PRODUTO.CDPRODESTO,
                              OPERADOR.CDOPERADOR,
                              PRODUTO.CDARVPROD,
                              PRODUTO.SGUNIDADE,
                              PRODUTO.NMPRODUTO,
                              FORNECEDOR.NMFANTFORN,
                              NVL(PRODACOMPRAR.QTACOMPRAR, 0) AS QTACOMPRAR,
                              REGIAO.CDREGIAO,
                              PRODUTO.CDPRODUTO,
                              OPERADOR.NMOPERADOR,
                              MARCA.NMMARCA,
                              MARCA.CDMARCA AS CDMARCAPADR,
                              PRODCOMPRA.NRCOMPRA
                         FROM PARASUPRI, PRODUTO, MARCPRODCOMP, FILIAL FILI, COMPRA, PRODCOMPRA, FORPRCOMPRA,
                              (SELECT COMP.CDREGIAO, COMP.CDPRODUTO, ROUND((COMP.QTDECOMP-NVL(JACOMP.QTDECOMP,0)) / COMP.VRFATOCONV, 5) AS QTACOMPRAR
                                 FROM (SELECT FILIAL.CDREGIAO, PRODUTO.CDPRODESTO, PRODUTO.CDPRODUTO, PRODUTO.VRFATOCONV, SUM(ITEMSOLI.QTSOLIPROD*PRODUTO.VRFATOCONV) AS QTDECOMP
                                         FROM FILIAL, PRODUTO, PRODCOMPRA, REGIAO, ITEMSOLI
                                        WHERE (PRODCOMPRA.CDFILSOLI = FILIAL.CDFILIAL)
                                          AND (PRODCOMPRA.CDPRODUTO = PRODUTO.CDPRODUTO)
                                          AND (PRODCOMPRA.DTPROGENTR BETWEEN '$dtini'  AND '$dtfin')
                                          AND (PRODUTO.CDARVPROD BETWEEN '$cdprodini'  AND '$cdprodfin')
                                          AND (FILIAL.CDREGIAO = REGIAO.CDREGIAO)
                                          AND (PRODCOMPRA.CDFILSOLI = ITEMSOLI.CDFILSOLI)
                                          AND (PRODCOMPRA.CDFILLAN = ITEMSOLI.CDFILLAN)
                                          AND (PRODCOMPRA.NRSOLICMP = ITEMSOLI.NRSOLICMP)
                                          AND (PRODCOMPRA.DTPROGENTR = ITEMSOLI.DTPROGENTR)
                                          AND (PRODCOMPRA.CDPRODUTO = ITEMSOLI.CDPRODUTO)
                                        GROUP BY FILIAL.CDREGIAO, PRODUTO.CDPRODESTO, PRODUTO.CDPRODUTO, PRODUTO.VRFATOCONV) COMP,
                                      (SELECT FILIAL.CDREGIAO, PRODUTO.CDPRODESTO, SUM(ITEMAUTF.QTPROGENTAF*PRODUTO.VRFATOCONV) AS QTDECOMP
                                         FROM ITEMAUTF, AUTOFORNE, FILIAL, PRODUTO, PRODCOMPRA, REGIAO
                                        WHERE (AUTOFORNE.CDFILDEST = ITEMAUTF.CDFILDEST)
                                          AND (AUTOFORNE.CDFILLANC = ITEMAUTF.CDFILLANC)
                                          AND (AUTOFORNE.NRAUTOFORN = ITEMAUTF.NRAUTOFORN)
                                          AND (AUTOFORNE.CDFILDEST = FILIAL.CDFILIAL)
                                          AND (ITEMAUTF.CDPRODUTO = PRODUTO.CDPRODUTO)
                                          AND (ITEMAUTF.DTENTRITMSOL BETWEEN '$dtini'  AND '$dtfin')
                                          AND (PRODCOMPRA.CDFILSOLI = FILIAL.CDFILIAL)
                                          AND (FILIAL.CDREGIAO = REGIAO.CDREGIAO)
                                          AND (AUTOFORNE.IDSITUATUAAF IS NULL)
                                          AND (AUTOFORNE.IDAFFORALIM = 'N')
                                          AND (AUTOFORNE.IDAUTOFORNEX = 'N')
                                          AND (NVL(AUTOFORNE.IDBAIXAAF, '0') <> '5')
                                        GROUP BY FILIAL.CDREGIAO, PRODUTO.CDPRODESTO) JACOMP
                                WHERE (COMP.CDREGIAO = JACOMP.CDREGIAO (+))
                                  AND (COMP.CDPRODESTO = JACOMP.CDPRODESTO (+))
                                  AND (ROUND((COMP.QTDECOMP-NVL(JACOMP.QTDECOMP,0)) / COMP.VRFATOCONV, 5) > 0))PRODACOMPRAR,
                               REGIAO,
                             OPERADOR,
                              (SELECT CDFORNECED, IDTPIJURFORN, NRINSJURFORN, NMRAZSOCFORN, NMFANTFORN, IDTPFRETFORN
                                 FROM FORNECEDOR
                                WHERE INSTR('$cdforneced' , CDFORNECED) <> 0 OR '$Tcdforneced'  = 'T' )FORNECEDOR,
                              (SELECT CDMARCA, NMMARCA, IDMARCAATIVA
                                 FROM MARCA
                                WHERE INSTR('$cdmarca', CDMARCA) <> 0 OR '$Tcdmarca' = 'T') MARCA
                        WHERE (FILI.CDFILIAL = PRODCOMPRA.CDFILSOLI)
                          AND (PARASUPRI.CDFILIAL = NVL(FILI.CDFILCENTCMP, FILI.CDFILIAL))
                          AND (FILI.CDREGIAO = REGIAO.CDREGIAO)
                          AND (NVL(PARASUPRI.IDCONSPRSOL, 'N') = 'S')
                          AND (COMPRA.NRCOMPRA = '$nrcompra')
                          AND (PRODUTO.CDARVPROD BETWEEN '$cdprodini'  AND '$cdprodfin')
                          AND (COMPRA.CDCOMPRADOR  = OPERADOR.CDOPERADOR)
                          AND (COMPRA.NRCOMPRA = PRODCOMPRA.NRCOMPRA)
                          AND (FORPRCOMPRA.NRCOMPRA = PRODCOMPRA.NRCOMPRA)
                          AND (PRODCOMPRA.CDPRODUTO = PRODACOMPRAR.CDPRODUTO(+))
                          AND (PRODCOMPRA.CDPRODUTO  = PRODUTO.CDPRODUTO)
                          AND (FORPRCOMPRA.CDFORNECED = FORNECEDOR.CDFORNECED)
                          AND (PRODCOMPRA.CDPRODUTO  = MARCPRODCOMP.CDPRMARCOMPL)
                          AND (MARCPRODCOMP.CDMARCA = MARCA.CDMARCA)
                          AND (MARCA.IDMARCAATIVA       = 'A'
                          AND (FILI.IDFUNCAOFILI IS NULL)
                        UNION ALL
                       SELECT FORNECEDOR.CDFORNECED,
                              FORNECEDOR.IDTPIJURFORN,
                              FORNECEDOR.NRINSJURFORN,
                              FORNECEDOR.NMRAZSOCFORN,
                              FORNECEDOR.IDTPFRETFORN,
                              REGIAO.NMREGIAO,
                              MARCA.CDMARCA,
                              PRODUTO.CDPRODESTO,
                              OPERADOR.CDOPERADOR,
                              PRODUTO.CDARVPROD,
                              PRODUTO.SGUNIDADE,
                              PRODUTO.NMPRODUTO,
                              FORNECEDOR.NMFANTFORN,
                              NVL(PRODACOMPRAR.QTACOMPRAR, 0) AS QTACOMPRAR,
                              REGIAO.CDREGIAO,
                              PRODUTO.CDPRODUTO,
                              OPERADOR.NMOPERADOR,
                              MARCA.NMMARCA,
                              MARCA.CDMARCA AS CDMARCAPADR,
                              PRODCOMPRA.NRCOMPRA
                         FROM PARASUPRI, COMPRA, PRODCOMPRA, FORPRCOMPRA, PRODUTO, MARCPRODCOMP,
                              (SELECT COMP.CDREGIAO, COMP.CDPRODUTO, ROUND((COMP.QTDECOMP-NVL(JACOMP.QTDECOMP,0)) / COMP.VRFATOCONV, 5) AS QTACOMPRAR
                                 FROM (SELECT FILIAL.CDREGIAO, PRODUTO.CDPRODESTO, PRODUTO.CDPRODUTO, PRODUTO.VRFATOCONV, SUM(ITEMSOLI.QTSOLIPROD*PRODUTO.VRFATOCONV) AS QTDECOMP
                                         FROM FILIAL, PRODUTO, PRODCOMPRA, REGIAO, ITEMSOLI
                                        WHERE (PRODCOMPRA.CDFILSOLI = FILIAL.CDFILIAL)
                                          AND (PRODCOMPRA.DTPROGENTR BETWEEN '$dtini'  AND '$dtfin')
                                          AND (PRODUTO.CDARVPROD BETWEEN '$cdprodini'  AND '$cdprodfin')
                                          AND (FILIAL.CDREGIAO = REGIAO.CDREGIAO)
                                          AND (PRODCOMPRA.CDPRODUTO = PRODUTO.CDPRODUTO)
                                          AND (PRODCOMPRA.CDFILSOLI = ITEMSOLI.CDFILSOLI)
                                          AND (PRODCOMPRA.CDFILLAN = ITEMSOLI.CDFILLAN)
                                          AND (PRODCOMPRA.NRSOLICMP = ITEMSOLI.NRSOLICMP)
                                          AND (PRODCOMPRA.DTPROGENTR = ITEMSOLI.DTPROGENTR)
                                          AND (PRODCOMPRA.CDPRODUTO = ITEMSOLI.CDPRODUTO)
                                        GROUP BY FILIAL.CDREGIAO, PRODUTO.CDPRODESTO, PRODUTO.CDPRODUTO, PRODUTO.VRFATOCONV) COMP,
                                      (SELECT FILIAL.CDREGIAO, PRODUTO.CDPRODESTO, SUM(ITEMAUTF.QTPROGENTAF*PRODUTO.VRFATOCONV) AS QTDECOMP
                                         FROM ITEMAUTF, AUTOFORNE, FILIAL, PRODUTO, PRODCOMPRA, REGIAO
                                        WHERE (AUTOFORNE.CDFILDEST = ITEMAUTF.CDFILDEST)
                                          AND (AUTOFORNE.CDFILLANC = ITEMAUTF.CDFILLANC)
                                          AND (AUTOFORNE.NRAUTOFORN = ITEMAUTF.NRAUTOFORN)
                                          AND (AUTOFORNE.CDFILDEST = FILIAL.CDFILIAL)
                                          AND (ITEMAUTF.DTENTRITMSOL BETWEEN '$dtini'  AND '$dtfin')
                                          AND (ITEMAUTF.CDPRODUTO = PRODUTO.CDPRODUTO)
                                          AND (PRODCOMPRA.CDFILSOLI = FILIAL.CDFILIAL)
                                          AND (FILIAL.CDREGIAO = REGIAO.CDREGIAO)
                                          AND (AUTOFORNE.IDSITUATUAAF IS NULL)
                                          AND (AUTOFORNE.IDAFFORALIM = 'N')
                                          AND (AUTOFORNE.IDAUTOFORNEX = 'N')
                                          AND (NVL(AUTOFORNE.IDBAIXAAF, '0') <> '5')
                                        GROUP BY FILIAL.CDREGIAO, PRODUTO.CDPRODESTO) JACOMP
                                WHERE (COMP.CDREGIAO = JACOMP.CDREGIAO (+))
                                  AND (COMP.CDPRODESTO = JACOMP.CDPRODESTO (+))
                                  AND (ROUND((COMP.QTDECOMP-NVL(JACOMP.QTDECOMP,0)) / COMP.VRFATOCONV, 5) > 0))PRODACOMPRAR,
                             REGIAO,
                             OPERADOR,
                             FILIAL,
                             (SELECT CDFORNECED, IDTPIJURFORN, NRINSJURFORN, NMRAZSOCFORN, NMFANTFORN, IDTPFRETFORN
                                FROM FORNECEDOR
                               WHERE INSTR('$cdforneced' , CDFORNECED) <> 0 OR '$Tcdforneced'  = 'T' )FORNECEDOR,
                             (SELECT CDMARCA, NMMARCA, IDMARCAATIVA
                                FROM MARCA
                               WHERE INSTR('$cdmarca', CDMARCA) <> 0 OR '$Tcdmarca' = 'T') MARCA,
                             (SELECT PARAMPRODSUP.CDREGIAO, PARAMPRODSUP.CDPRODUTO
                                FROM PARAMPRODSUP, FILIAL, PRODCOMPRA
                               WHERE (PRODCOMPRA.CDFILSOLI = FILIAL.CDFILIAL)
                                 AND (FILIAL.IDFUNCAOFILI = 'C')
                                 AND (FILIAL.CDFILIAL = PARAMPRODSUP.CDFILICTRL)
                                 AND (PARAMPRODSUP.IDFILINEGCOR = 'S')
                               UNION ALL
                              SELECT PARAMPRODSUP.CDREGIAO, PARAMPRODSUP.CDPRODUTO
                                FROM PARAMPRODSUP, FILIAL, PRODCOMPRA
                               WHERE (PRODCOMPRA.CDFILSOLI = FILIAL.CDFILIAL)
                                 AND (FILIAL.IDFUNCAOFILI = 'R')
                                 AND (FILIAL.CDFILIAL = PARAMPRODSUP.CDFILICTRL)
                                 AND (PARAMPRODSUP.IDFILINEGREG = 'S')) PARAMPRODSUP
                        WHERE (COMPRA.NRCOMPRA = PRODCOMPRA.NRCOMPRA)
                          AND (PRODCOMPRA.NRCOMPRA = FORPRCOMPRA.NRCOMPRA)
                          AND (COMPRA.NRCOMPRA = '$nrcompra')
                          AND (PRODUTO.CDARVPROD BETWEEN '$cdprodini'  AND '$cdprodfin')
                          AND (FILIAL.CDFILIAL = PRODCOMPRA.CDFILSOLI)
                          AND (PARASUPRI.CDFILIAL = NVL(FILIAL.CDFILCENTCMP, FILIAL.CDFILIAL))
                          AND (FILIAL.CDREGIAO = REGIAO.CDREGIAO)
                          AND (NVL(PARASUPRI.IDCONSPRSOL, 'N') = 'S')
                          AND (COMPRA.CDCOMPRADOR  = OPERADOR.CDOPERADOR)
                          AND (PRODCOMPRA.CDPRODUTO = PRODACOMPRAR.CDPRODUTO(+))
                          AND (PRODCOMPRA.CDPRODUTO  = PRODUTO.CDPRODUTO)
                          AND (FORPRCOMPRA.CDFORNECED = FORNECEDOR.CDFORNECED)
                          AND (PRODCOMPRA.CDPRODUTO  = MARCPRODCOMP.CDPRMARCOMPL)
                          AND (MARCPRODCOMP.CDMARCA = MARCA.CDMARCA)
                          AND (MARCA.IDMARCAATIVA       = 'A')
                          AND (PARAMPRODSUP.CDPRODUTO = PRODCOMPRA.CDPRODUTO)
                          AND (PARAMPRODSUP.CDREGIAO  = FILIAL.CDREGIAO)) A
                        ORDER BY CDOPERADOR, CDFORNECED, CDREGIAO, NMPRODUTO";
            return $this->getEntityManager()->getConnection()->fetchAll($sql);
        }
        catch(\Exception $e){
            throw $e;
        }
    }
    public function queryGetExistPedCol($cdregiao, $cdforneced, $dtinicial, $dtfinal){
        try{
            $sql = "SELECT MAX(CDREGIAO) CDREGIAO
                      FROM PEDCOLETA
                     WHERE CDREGIAO    = '$cdregiao'
                       AND CDFORNECED  = '$cdforneced'
                       AND DTINIPERCOT = '$dtinicial'
                       AND DTFINPERCOT = '$dtfinal'";

            return $this->getEntityManager()->getConnection()->fetchAll($sql);
        }
        catch(\Exception $e){
            throw $e;
        }
    }

    public function queryGetMarcProd($cdproduto){
        try{
            $sql = "   SELECT MARCPROD.CDPRODUTO,
                              MARCPROD.CDMARCA,
                              MARCPROD.NMMARCA,
                              MARCPROD.MARCCAD,
                              MARCPROD.CDARVPROD,
                              MARCPROD.VRARREDEMPMAR
                            FROM (SELECT MARCPROD.CDPRODUTO,
                                         MARCPROD.CDMARCA,
                                         MARCA.NMMARCA,
                                         '0' AS MARCCAD,
                                         PRODUTO.CDARVPROD,
                                         MARCPROD.VRARREDEMPMAR
                                    FROM PRODUTO, MARCPROD, MARCA
                                   WHERE (MARCPROD.CDPRODUTO = PRODUTO.CDPRODUTO)
                                     AND (PRODUTO.CDARVPROD = '$cdproduto'      )
                                     AND (MARCPROD.CDMARCA   = MARCA.CDMARCA    )
                                   UNION
                                  SELECT MARCPROD.CDPRODUTO,
                                         MARCPROD.CDMARCA,
                                         MARCA.NMMARCA,
                                         '1' AS MARCCAD,
                                         PRODUTO.CDARVPROD,
                                         MARCPROD.VRARREDEMPMAR
                                    FROM PRODUTO, MARCPROD, MARCA
                                   WHERE (PRODUTO.CDPRODUTO = MARCPROD.CDPRODUTO)
                                     AND (PRODUTO.CDARVPROD <> '$cdproduto')
                                     AND ('$cdproduto' LIKE PRODUTO.CDARVPROD || '%')
                                     AND (MARCPROD.CDMARCA   = MARCA.CDMARCA)
                                     AND (PRODUTO.CDARVPROD = (SELECT MAX(P.CDARVPROD)
                                                                 FROM MARCPROD MP, PRODUTO  P
                                                                WHERE (MP.CDPRODUTO = P.CDPRODUTO)
                                                                  AND ('$cdproduto' LIKE P.CDARVPROD || '%')
                                                                  AND (MP.CDMARCA = MARCPROD.CDMARCA))) ) MARCPROD
                          ORDER BY 4, 3";

            return $this->getEntityManager()->getConnection()->fetchAll($sql);
        }
        catch(\Exception $e){
            throw $e;
        }
    }


    public function queryGridXls($nrcompra,$cdfilial,$cdforneced){
        try{
            $sql = "SELECT DISTINCT PRODCOMPRA.CDPRODUTO,
                                    PRODUTO.NMPRODUTO,
                                    PRODCOMPRA.DTPROGENTR,
                                    PRODUTO.SGUNIDADE,
                                    ITEMSOLI.QTSOLIPROD,
                                    NVL(PARASUPRI.CDMARCA,MARCPROD.CDMARCA),
                                    MARCA.NMMARCA,
                                    NVL((SELECT MIN(A.VRPRECUNIITM)
                                            FROM ITEMCOLE A
                                           WHERE A.CDFILIAL = NVL(FILIAL.CDFILCENTCMP,FILIAL.CDFILIAL)  AND
                                                 A.CDMARCA = NVL(PARASUPRI.CDMARCA,MARCPROD.CDMARCA) AND
                                                 A.CDREGIAO = FILIAL.CDREGIAO AND
                                                 A.CDFORNECED = PRODFORNCOMP.CDFORNECED AND
                                                 A.CDPRODUTO = ITEMSOLI.CDPRODUTO AND
                                                 A.VRPRECUNIITM > 0 AND
                                                 A.DTFINVALITM = (SELECT MAX(ITEMCOLE.DTFINVALITM)
                                                                    FROM ITEMCOLE
                                                                   WHERE ITEMCOLE.CDFILIAL = NVL(FILIAL.CDFILCENTCMP,FILIAL.CDFILIAL) AND
                                                                         ITEMCOLE.CDMARCA = NVL(PARASUPRI.CDMARCA,MARCPROD.CDMARCA) AND
                                                                         ITEMCOLE.CDREGIAO = FILIAL.CDREGIAO AND
                                                                         ITEMCOLE.CDFORNECED = PRODFORNCOMP.CDFORNECED AND
                                                                         ITEMCOLE.VRPRECUNIITM > 0 AND
                                                                         ITEMCOLE.CDPRODUTO = ITEMSOLI.CDPRODUTO)),0) VRPRECOANT
                      FROM PRODCOMPRA,
                           FILIAL,
                           FILIAL FILILAN,
                           PRODUTO,
                           ITEMSOLI,
                           MARCPROD,
                           MARCA,
                           PRODFORNCOMP,
                           PARASUPRI
                     WHERE PRODCOMPRA.CDFILSOLI   = FILIAL.CDFILIAL
                       AND PARASUPRI.CDFILIAL     = NVL(FILIAL.CDFILCENTCMP,FILIAL.CDFILIAL)
                       AND PRODCOMPRA.CDFILLAN    = FILILAN.CDFILIAL
                       AND PRODCOMPRA.CDPRODUTO   = PRODUTO.CDPRODUTO
                       AND ITEMSOLI.CDFILSOLI     = PRODCOMPRA.CDFILSOLI
                       AND ITEMSOLI.CDFILLAN      = PRODCOMPRA.CDFILLAN
                       AND ITEMSOLI.NRSOLICMP     = PRODCOMPRA.NRSOLICMP
                       AND ITEMSOLI.CDPRODUTO     = PRODCOMPRA.CDPRODUTO
                       AND ITEMSOLI.DTPROGENTR    = PRODCOMPRA.DTPROGENTR
                       AND NVL(PARASUPRI.CDMARCA,MARCPROD.CDMARCA) = MARCA.CDMARCA
                       AND ITEMSOLI.CDPRODUTO LIKE (SELECT MAX(CDARVPROD)
                                                      FROM MARCPROD MP,
                                                           PRODUTO P
                                                     WHERE (MP.CDPRODUTO = P.CDPRODUTO)
                                                       AND ITEMSOLI.CDPRODUTO LIKE P.CDARVPROD|| '%')|| '%'
                                                       AND PRODFORNCOMP.CDPRODCOMPL=PRODUTO.CDPRODUTO
                                                       AND PRODCOMPRA.NRCOMPRA     = '$nrcompra'
                                                       AND PRODCOMPRA.CDFILSOLI    = '$cdfilial'
                                                       AND PRODFORNCOMP.CDFORNECED = '$cdforneced'";
            return $this->getEntityManager()->getConnection()->fetchAll($sql);
        }
        catch(\Exception $e){
            throw $e;
        }
    }
    public function queryGetDistinctFilialSolicitante($nrcompra){
        try{
            $sql = "SELECT DISTINCT CDFILSOLI
                      FROM PRODCOMPRA
                     WHERE NRCOMPRA = '$nrcompra'";
            return $this->getEntityManager()->getConnection()->fetchAll($sql);
        }
        catch(\Exception $e){
            throw $e;
        }
    }
    public function queryGetNrcolepreco($nrcompra){
        try{
            $sql="SELECT COLETAPR.NRCOLEPRECO
                    FROM COLETAPR,COMPRA
                   WHERE COLETAPR.NRCOMPRA=COMPRA.NRCOMPRA
                     AND COMPRA.NRCOMPRA='$nrcompra'";
            return $this->getEntityManager()->getConnection()->fetchAll($sql);
        }
        catch(\Exception $e){
            throw $e;
        }
    }


    public function queryDistinctFilisoli($nrcompra){
        try{
            $sql = "SELECT DISTINCT CDFILSOLI
                      FROM PRODCOMPRA
                     WHERE NRCOMPRA = '$nrcompra'";
            return $this->getEntityManager()->getConnection()->fetchAll($sql);
        }
        catch(\Exception $e){
            throw $e;
        }
    }
    public function queryRegiaoCompra($nrcompra){
        try{
            $sql = "SELECT DISTINCT FILIAL.CDREGIAO
                      FROM PRODCOMPRA
                     INNER JOIN FILIAL
                        ON CDFILSOLI = CDFILIAL
                      WHERE PRODCOMPRA.NRCOMPRA = '$nrcompra'";
            return $this->getEntityManager()->getConnection()->fetchAll($sql);
        }
        catch(\Exception $e){
            throw $e;
        }
    }

    public function queryRegiaoFornecedorCompra($nrcompra,$cdforneced){
        try{
            $sql = "SELECT DISTINCT FILIAL.CDREGIAO
                      FROM PRODCOMPRA
                     INNER JOIN FILIAL
                        ON CDFILSOLI = CDFILIAL
                     WHERE PRODCOMPRA.NRCOMPRA = '$nrcompra'
                       AND FILIAL.CDFILIAL NOT IN (SELECT CDFILIAL
                                                     FROM REFORFIL
                                                    WHERE CDFORNECED = '$cdforneced')";
            return $this->getEntityManager()->getConnection()->fetchAll($sql);
        }
        catch(\Exception $e){
            throw $e;
        }
    }


}