-- =============================================================================
-- Sistema   : Comercial Comissaria
-- Data      : 31/01/2003
-- Criao   : Leonardo Monteiro
-- Obsjetivo : Retorna o item da ficha com a frmula calculada.
-- =============================================================================
-- @C:\WIN_V4\SQL\END_CONV\ORACLE\1310_COCSTPO.sql
-- =============================================================================
CREATE OR REPLACE PROCEDURE RETORNA_ITEMFICHAMU(
P_IDSITFROM    IN  VARCHAR2, -- 'F' = FICHA, 'I' ITEM
P_CDFILIAL     IN  ITFORMPRECIA.CDFILIAL    %TYPE,
P_NRFORMPRECIA IN  ITFORMPRECIA.NRFORMPRECIA%TYPE,
P_CDMARKUP     IN  ITFICHAFPRMU.CDMARKUP    %TYPE,
P_CDFICHAFPR   IN  ITFICHAFPRMU.CDFICHAFPR  %TYPE,
P_CDITFICHAFPR IN  ITFICHAFPRMU.CDITFICHAFPR%TYPE,
P_DSFORMITFIMU IN  ITFICHAFPRMU.DSFORMITFIMU%TYPE,
P_RESULTADO    OUT VARCHAR2
)
AS
V_CDITFICHAFPR ITFICHAFPRMU.CDITFICHAFPR%TYPE;
V_DSFORMITFIMU ITFICHAFPRMU.DSFORMITFIMU%TYPE;
V_DSFORMITEM   ITFICHAFPRMU.DSFORMITFIMU%TYPE;
V_TESTE        NUMBER;

V_INSERT_TEXT  VARCHAR2(1000);
C_INSERT       INTEGER;
V_RESULT       INTEGER;
BEGIN
	V_DSFORMITFIMU := P_DSFORMITFIMU;

   FOR C_ITEM IN(SELECT IM.CDITFICHAFPR,IP.SGITFICHAFPR,IM.DSFORMITFIMU
                 FROM ITFICHAFPRMU IM, ITFICHAFPR IP
                 WHERE (IM.CDMARKUP      = P_CDMARKUP      ) AND
                       (IM.CDFICHAFPR    = P_CDFICHAFPR    ) AND
                       --(IM.IDITFICHAFPR <> 'S'             ) AND
                       (IP.CDFICHAFPR    = P_CDFICHAFPR    ) AND
                       (IP.CDITFICHAFPR  = IM.CDITFICHAFPR ) AND
                       (INSTR(V_DSFORMITFIMU,IP.SGITFICHAFPR)>0) AND
                       (TRIM(IM.DSFORMITFIMU) IS NOT NULL)) LOOP

		V_CDITFICHAFPR := C_ITEM.CDITFICHAFPR;

   	IF P_IDSITFROM = 'F' THEN
      	V_DSFORMITEM := C_ITEM.DSFORMITFIMU;
      ELSE
      	V_DSFORMITEM := REPLACE(P_DSFORMITFIMU,C_ITEM.SGITFICHAFPR,C_ITEM.DSFORMITFIMU);
      END IF;

      SELECT COUNT(*)
      INTO V_TESTE
      FROM ITFICHAFPR
      WHERE (CDFICHAFPR = P_CDFICHAFPR) AND
            (INSTR(V_DSFORMITEM,SGITFICHAFPR)>0);

   	IF P_IDSITFROM = 'F' THEN
         IF (V_TESTE <> 0) THEN
            RETORNA_ITEMFICHAMU('I',P_CDFILIAL,P_NRFORMPRECIA,P_CDMARKUP,P_CDFICHAFPR,C_ITEM.CDITFICHAFPR,C_ITEM.DSFORMITFIMU,V_DSFORMITEM);
         END IF;
         /* Grava os itens das fichas do Mark-up */
         V_INSERT_TEXT := '';
         V_INSERT_TEXT := V_INSERT_TEXT||' INSERT INTO ITFORMPRECIA';
         V_INSERT_TEXT := V_INSERT_TEXT||' (CDFILIAL,NRFORMPRECIA,CDFICHAFPR,CDITFICHAFPR,DSFOITFOPCIA)';
         V_INSERT_TEXT := V_INSERT_TEXT||' VALUES';
         V_INSERT_TEXT := V_INSERT_TEXT||' ('''||P_CDFILIAL||''','''||P_NRFORMPRECIA||''','''||P_CDFICHAFPR||''','''||C_ITEM.CDITFICHAFPR||''',';
         V_INSERT_TEXT := V_INSERT_TEXT||' NVL('||REPLACE(V_DSFORMITEM,',','.')||',0))';

         C_INSERT := DBMS_SQL.OPEN_CURSOR;
         DBMS_SQL.PARSE(C_INSERT,V_INSERT_TEXT,DBMS_SQL.V7);

         V_RESULT := DBMS_SQL.EXECUTE(C_INSERT);
         DBMS_SQL.CLOSE_CURSOR(C_INSERT);

   	ELSIF (V_TESTE <> 0) THEN
      	RETORNA_ITEMFICHAMU('I',P_CDFILIAL,P_NRFORMPRECIA,P_CDMARKUP,P_CDFICHAFPR,C_ITEM.CDITFICHAFPR,C_ITEM.DSFORMITFIMU,V_DSFORMITEM);
      END IF;

      V_DSFORMITFIMU := REPLACE(V_DSFORMITFIMU,C_ITEM.SGITFICHAFPR,V_DSFORMITEM);
   END LOOP;

   P_RESULTADO := V_DSFORMITFIMU;
EXCEPTION
	WHEN OTHERS THEN
   	IF DBMS_SQL.IS_OPEN(C_INSERT) THEN
   		DBMS_SQL.CLOSE_CURSOR(C_INSERT);
   		raise_application_error(-20502, 'No foi possvel calcular a frmula do item '||V_CDITFICHAFPR||
                                         ' da ficha '||P_CDFICHAFPR||'. Verifique esta frmula e tente novamente.', false);
      ELSE
      	RAISE;
      END IF;
END;
/
