/*
 Tecnisa - Tecnologia em Informtica

 Nome: Exclui contas exportadas

 Descrio:
 Procedimento para excluso de todas as contas ligadas  nota fiscal, boletos referentes as contas,
   baixas e movimentos bancarios

 Criao:
 26/04/2002 - Jenilson Ferreira de Andrade

 Chamada para criao
 @C:\Win_Prj\Sql\SqlServer\1007_PAGSTP_EXCLUI_CONTAPAG_EXPORTADA.SQL;

 */

IF EXISTS (SELECT
              *
           FROM SYSOBJECTS O, SYSUSERS U
           WHERE
              O.NAME = 'EXCLUI_CONTAPAG_EXPORTADA' AND
              TYPE   = 'P'           	            AND
              U.UID  = O.UID                       AND
              U.NAME = USER)

DROP PROCEDURE EXCLUI_CONTAPAG_EXPORTADA
GO

CREATE PROCEDURE EXCLUI_CONTAPAG_EXPORTADA
   @P_CDFILIAL    VARCHAR(04),
   @P_NRLANCTONF  VARCHAR(10)

AS
   DECLARE @V_CDREDUBX                 VARCHAR(03);
   DECLARE @V_NRMOVBANC                VARCHAR(10);
   DECLARE @V_CDSEQUEXBA               VARCHAR(10);
   DECLARE @V_NRSEQMOVREBA             VARCHAR(10);
   DECLARE @V_CDFILIBAIPAG             VARCHAR(04);
   DECLARE @V_NRBAIXAPAG               VARCHAR(10);

   DECLARE @V_VRAJBOLPAG               DOUBLE PRECISION;
   DECLARE @V_VRAJUCTPAG               DOUBLE PRECISION;
   DECLARE @V_VRORIGPAG                DOUBLE PRECISION;
   DECLARE @V_CTDEL                    DOUBLE PRECISION;

/*   CURSOR  CNTPAG    */
   DECLARE @V_CNTPAG_CDFILIAL          VARCHAR(04);
   DECLARE @V_CNTPAG_NRLANCTONF        VARCHAR(10);
   DECLARE @V_CNTPAG_NRSEQVENPAG       VARCHAR(02);
   DECLARE @V_CNTPAG_VRATUAPAG         DOUBLE PRECISION;
   DECLARE @V_CNTPAG_CDFILIBPAG        VARCHAR(04);
   DECLARE @V_CNTPAG_NRLANBOLPAG       VARCHAR(10);
   DECLARE @V_CNTPAG_CDEMPRESA         VARCHAR(02);
   DECLARE @V_CNTPAG_CDFIMOVFLPAG      VARCHAR(04);
   DECLARE @V_CNTPAG_DTMOVFLUXO        DATETIME;
   DECLARE @V_CNTPAG_IDMOVFLUXO        VARCHAR(01);
   DECLARE @V_CNTPAG_CDCLASSFINA       VARCHAR(06);
   DECLARE @V_CNTPAG_VRORIGPAG         DOUBLE PRECISION;
   DECLARE @V_CNTPAG_NRPARCELAPAG      VARCHAR(02);

/*         FETCH NEXT FROM C_CNTPAG_BX INTO   */
   DECLARE @V_CNTPAG_BX_CDFILIAL       VARCHAR(04);
   DECLARE @V_CNTPAG_BX_NRLANCTONF     VARCHAR(10);
   DECLARE @V_CNTPAG_BX_NRSEQVENPAG    VARCHAR(02);
   DECLARE @V_CNTPAG_BX_CDFILIBPAG     VARCHAR(04);
   DECLARE @V_CNTPAG_BX_NRLANBOLPAG    VARCHAR(10);
   DECLARE @V_CNTPAG_BX_CDEMPRESA      VARCHAR(02);
   DECLARE @V_CNTPAG_BX_CDFIMOVFLPAG   VARCHAR(04);
   DECLARE @V_CNTPAG_BX_DTMOVFLUXO     DATETIME;
   DECLARE @V_CNTPAG_BX_IDMOVFLUXO     VARCHAR(01);
   DECLARE @V_CNTPAG_BX_CDCLASSFINA    VARCHAR(06);
   DECLARE @V_CNTPAG_BX_VRORIGPAG      DOUBLE PRECISION;
   DECLARE @V_CNTPAG_BX_NRPARCELAPAG   VARCHAR(02);

/*       FETCH NEXT FROM C_BOLETPAG_AB INTO    */
   DECLARE @V_BOLETPAG_AB_CDFILIAL     VARCHAR(04);
   DECLARE @V_BOLETPAG_AB_NRLANCTONF   VARCHAR(10);
   DECLARE @V_BOLETPAG_AB_NRSEQVENPAG  VARCHAR(02);
   DECLARE @V_BOLETPAG_AB_CDFILIBPAG   VARCHAR(04);
   DECLARE @V_BOLETPAG_AB_NRLANBOLPAG  VARCHAR(10);
   DECLARE @V_BOLETPAG_AB_CDEMPRESA    VARCHAR(02);
   DECLARE @V_BOLETPAG_AB_CDFIMOVFLPAG VARCHAR(04);
   DECLARE @V_BOLETPAG_AB_DTMOVFLUXO   DATETIME;
   DECLARE @V_BOLETPAG_AB_IDMOVFLUXO   VARCHAR(01);
   DECLARE @V_BOLETPAG_AB_CDCLASSFINA  VARCHAR(06);
   DECLARE @V_BOLETPAG_AB_VRORIGPAG    DOUBLE PRECISION;
   DECLARE @V_BOLETPAG_AB_NRPARCELAPAG VARCHAR(02);

/*          FETCH NEXT FROM C_RATR_A INTO    */
   DECLARE @V_RATR_A_CDFILIAL          VARCHAR(04);
   DECLARE @V_RATR_A_NRLANBOLPAG       VARCHAR(10);
   DECLARE @V_RATR_A_CDAJUCTPAG        VARCHAR(04);
   DECLARE @V_RATR_A_VRAJBOLPAG        DOUBLE PRECISION;
   DECLARE @V_RATR_A_CDCLASSFINA       VARCHAR(06);
   DECLARE @V_RATR_A_CDEMPRESA         VARCHAR(02);
   DECLARE @V_RATR_A_CDFIMOVFLPAG      VARCHAR(04);
   DECLARE @V_RATR_A_DTMOVFLUXO        DATETIME;
   DECLARE @V_RATR_A_IDMOVFLUXO        VARCHAR(01);
   DECLARE @V_RATR_A_IDAJUCTPAG        VARCHAR(01);
   DECLARE @V_RATR_A_IDSTATPAG         VARCHAR(01);
   DECLARE @V_RATR_A_VRRATAJBOLPAG     DOUBLE PRECISION;

/*         FETCH NEXT FROM C_RATR_B INTO     */
   DECLARE @V_RATR_B_CDFILIAL          VARCHAR(04);
   DECLARE @V_RATR_B_NRLANBOLPAG       VARCHAR(10);
   DECLARE @V_RATR_B_CDAJUCTPAG        VARCHAR(04);
   DECLARE @V_RATR_B_VRAJBOLPAG        DOUBLE PRECISION;
   DECLARE @V_RATR_B_CDCLASSFINA       VARCHAR(06);
   DECLARE @V_RATR_B_CDEMPRESA         VARCHAR(02);
   DECLARE @V_RATR_B_CDFIMOVFLPAG      VARCHAR(04);
   DECLARE @V_RATR_B_DTMOVFLUXO        DATETIME;
   DECLARE @V_RATR_B_IDMOVFLUXO        VARCHAR(01);
   DECLARE @V_RATR_B_IDAJUCTPAG        VARCHAR(01);
   DECLARE @V_RATR_B_IDSTATPAG         VARCHAR(01);
   DECLARE @V_RATR_B_VRRATAJBOLPAG     DOUBLE PRECISION;


/*             FETCH NEXT FROM C_AJCTPAG_A INTO     */
   DECLARE @V_AJCTPAG_A_CDFILIAL       VARCHAR(04);
   DECLARE @V_AJCTPAG_A_NRLANCTONF     VARCHAR(10);
   DECLARE @V_AJCTPAG_A_CDAJUCTPAG     VARCHAR(04);
   DECLARE @V_AJCTPAG_A_CDCLASSFINA    VARCHAR(06);
   DECLARE @V_AJCTPAG_A_CDEMMFAJCNTP   VARCHAR(02);
   DECLARE @V_AJCTPAG_A_CDFIMFAJCNTP   VARCHAR(04);
   DECLARE @V_AJCTPAG_A_DTMOVFLUXO     DATETIME;
   DECLARE @V_AJCTPAG_A_IDMOVFLUXO     VARCHAR(01);
   DECLARE @V_AJCTPAG_A_VRAJUSTEPAG    DOUBLE PRECISION;
   DECLARE @V_AJCTPAG_A_IDAJUCTPAG     VARCHAR(01);
   DECLARE @V_AJCTPAG_A_NRSEQVENPAG    VARCHAR(02);
   DECLARE @V_AJCTPAG_A_NRPARCELAPAG   VARCHAR(02);

/*             FETCH NEXT FROM C_AJCTPAG_A INTO     */
   DECLARE @V_AJCTPAG_B_CDFILIAL       VARCHAR(04);
   DECLARE @V_AJCTPAG_B_NRLANCTONF     VARCHAR(10);
   DECLARE @V_AJCTPAG_B_CDAJUCTPAG     VARCHAR(04);
   DECLARE @V_AJCTPAG_B_CDCLASSFINA    VARCHAR(06);
   DECLARE @V_AJCTPAG_B_CDEMMFAJCNTP   VARCHAR(02);
   DECLARE @V_AJCTPAG_B_CDFIMFAJCNTP   VARCHAR(04);
   DECLARE @V_AJCTPAG_B_DTMOVFLUXO     DATETIME;
   DECLARE @V_AJCTPAG_B_IDMOVFLUXO     VARCHAR(01);
   DECLARE @V_AJCTPAG_B_VRAJUSTEPAG    DOUBLE PRECISION;
   DECLARE @V_AJCTPAG_B_IDAJUCTPAG     VARCHAR(01);
   DECLARE @V_AJCTPAG_B_NRSEQVENPAG    VARCHAR(02);
   DECLARE @V_AJCTPAG_B_NRPARCELAPAG   VARCHAR(02);

/*   CURSOR  BOLETPAG_BX  */
   DECLARE @V_BOLETPAG_BX_CDFILIAL     VARCHAR(04);
   DECLARE @V_BOLETPAG_BX_NRLANBOLPAG  VARCHAR(10);
   DECLARE @V_BOLETPAG_BX_CDFILIBAIPAG VARCHAR(04);
   DECLARE @V_BOLETPAG_BX_NRBAIXAPAG   VARCHAR(10);

BEGIN

   DECLARE C_CNTPAG CURSOR FOR
      SELECT CDFILIAL,    NRLANCTONF,   NRSEQVENPAG,
             VRATUAPAG,   CDFILIBPAG,   NRLANBOLPAG,
             CDEMPRESA,   CDFIMOVFLPAG, DTMOVFLUXO,
             IDMOVFLUXO,  CDCLASSFINA,  VRORIGPAG,
             NRPARCELAPAG
      FROM CONTAPAGAR
      WHERE CDFILIAL   = @P_CDFILIAL AND
            NRLANCTONF = @P_NRLANCTONF
      ORDER BY NRSEQVENPAG;
   OPEN C_CNTPAG;

   FETCH NEXT FROM C_CNTPAG INTO @V_CNTPAG_CDFILIAL,    @V_CNTPAG_NRLANCTONF,   @V_CNTPAG_NRSEQVENPAG,
                                 @V_CNTPAG_VRATUAPAG,   @V_CNTPAG_CDFILIBPAG,   @V_CNTPAG_NRLANBOLPAG,
                                 @V_CNTPAG_CDEMPRESA,   @V_CNTPAG_CDFIMOVFLPAG, @V_CNTPAG_DTMOVFLUXO,
                                 @V_CNTPAG_IDMOVFLUXO,  @V_CNTPAG_CDCLASSFINA,  @V_CNTPAG_VRORIGPAG,
                                 @V_CNTPAG_NRPARCELAPAG;
   WHILE (@@FETCH_STATUS = 0) BEGIN

      SELECT
         @V_CDFILIBAIPAG = MAX(BR.CDFILIBAIPAG),
         @V_NRBAIXAPAG   = MAX(BR.NRBAIXAPAG)
      FROM BOLETPAGAR BR, CONTAPAGAR CR
      WHERE
         (CR.CDFILIAL     = @V_CNTPAG_CDFILIAL)     AND
         (CR.NRLANCTONF   = @V_CNTPAG_NRLANCTONF)   AND
         (CR.NRSEQVENPAG  = @V_CNTPAG_NRSEQVENPAG)  AND
         (CR.NRPARCELAPAG = @V_CNTPAG_NRPARCELAPAG) AND
         (CR.CDFILIBPAG   = BR.CDFILIAL)            AND
         (CR.NRLANBOLPAG  = BR.NRLANBOLPAG);


      DECLARE C_BOLETPAG_BX CURSOR FOR
         SELECT CDFILIAL,     NRLANBOLPAG,
                CDFILIBAIPAG, NRBAIXAPAG
         FROM BOLETPAGAR
         WHERE (CDFILIBAIPAG = @V_CDFILIBAIPAG) AND
               (NRBAIXAPAG   = @V_NRBAIXAPAG);
      OPEN C_BOLETPAG_BX;
      FETCH NEXT FROM C_BOLETPAG_BX INTO @V_BOLETPAG_BX_CDFILIAL,     @V_BOLETPAG_BX_NRLANBOLPAG,
                                         @V_BOLETPAG_BX_CDFILIBAIPAG, @V_BOLETPAG_BX_NRBAIXAPAG;
      WHILE (@@FETCH_STATUS = 0) BEGIN

         DECLARE C_RATR_A CURSOR FOR
            SELECT AJ.CDFILIAL,     AJ.NRLANBOLPAG, AJ.CDAJUCTPAG,
                   AJ.VRAJBOLPAG,   CR.CDCLASSFINA, CR.CDEMPRESA,
                   CR.CDFIMOVFLPAG, CR.DTMOVFLUXO,  CR.IDMOVFLUXO,
                   TA.IDAJUCTPAG,   CR.IDSTATPAG,
                   (CASE MAX(BR.VRBOLPAG) WHEN 0
                    THEN 0
                    ELSE (MAX(AJ.VRAJBOLPAG) * SUM(CR.VRATUAPAG))/ MAX(BR.VRBOLPAG) END) VRRATAJBOLPAG
            FROM CONTAPAGAR  CR, BOLETPAGAR BR,
                 TIPOAJPAGAR TA, AJBOLPAG   AJ
            WHERE (AJ.CDFILIAL     = @V_BOLETPAG_BX_CDFILIAL)    AND
                  (AJ.NRLANBOLPAG  = @V_BOLETPAG_BX_NRLANBOLPAG) AND
                  (TA.CDAJUCTPAG   = AJ.CDAJUCTPAG)          AND
                  (BR.CDFILIAL     = AJ.CDFILIAL)            AND
                  (BR.NRLANBOLPAG  = AJ.NRLANBOLPAG)         AND
                  (CR.CDFILIBPAG   = BR.CDFILIAL)            AND
                  (CR.NRLANBOLPAG  = BR.NRLANBOLPAG)
            GROUP BY
               AJ.CDFILIAL,     AJ.NRLANBOLPAG, AJ.CDAJUCTPAG,
               AJ.VRAJBOLPAG,   CR.CDCLASSFINA, CR.CDEMPRESA,
               CR.CDFIMOVFLPAG, CR.DTMOVFLUXO,  CR.IDMOVFLUXO,
               TA.IDAJUCTPAG,   CR.IDSTATPAG;
         OPEN C_RATR_A;
         FETCH NEXT FROM C_RATR_A INTO @V_RATR_A_CDFILIAL,     @V_RATR_A_NRLANBOLPAG, @V_RATR_A_CDAJUCTPAG,
                                       @V_RATR_A_VRAJBOLPAG,   @V_RATR_A_CDCLASSFINA, @V_RATR_A_CDEMPRESA,
                                       @V_RATR_A_CDFIMOVFLPAG, @V_RATR_A_DTMOVFLUXO,  @V_RATR_A_IDMOVFLUXO,
                                       @V_RATR_A_IDAJUCTPAG,   @V_RATR_A_IDSTATPAG,   @V_RATR_A_VRRATAJBOLPAG
         WHILE (@@FETCH_STATUS = 0) BEGIN

            IF (@V_RATR_A_IDAJUCTPAG = 'D') BEGIN
               SET @V_VRAJBOLPAG = ROUND(@V_RATR_A_VRRATAJBOLPAG, 2);
            END
            ELSE BEGIN
               SET @V_VRAJBOLPAG = ROUND(@V_RATR_A_VRRATAJBOLPAG * -1, 2);
            END;
            /* - DESFAZ O FLUXO DE CAIXA -------------------------- */
            EXEC ATUALIZA_FLUXO_DE_CAIXA @V_RATR_A_CDEMPRESA,
                                         @V_RATR_A_CDFIMOVFLPAG,
                                         @V_RATR_A_DTMOVFLUXO,
                                         @V_RATR_A_IDMOVFLUXO,
                                         @V_RATR_A_CDCLASSFINA,
                                         0,
                                         @V_VRAJBOLPAG;

            DELETE FROM MOVFXAJBOLP
            WHERE CDFILIBOLPAG = @V_BOLETPAG_BX_CDFILIAL    AND
                  NRLANBOLPAG  = @V_BOLETPAG_BX_NRLANBOLPAG AND
                  CDAJUCTPAG   = @V_RATR_A_CDAJUCTPAG;

            FETCH NEXT FROM C_RATR_A INTO @V_RATR_A_CDFILIAL,     @V_RATR_A_NRLANBOLPAG, @V_RATR_A_CDAJUCTPAG,
                                          @V_RATR_A_VRAJBOLPAG,   @V_RATR_A_CDCLASSFINA, @V_RATR_A_CDEMPRESA,
                                          @V_RATR_A_CDFIMOVFLPAG, @V_RATR_A_DTMOVFLUXO,  @V_RATR_A_IDMOVFLUXO,
                                          @V_RATR_A_IDAJUCTPAG,   @V_RATR_A_IDSTATPAG,   @V_RATR_A_VRRATAJBOLPAG
         END;
         CLOSE C_RATR_A;
         DEALLOCATE C_RATR_A;

         DELETE FROM AJBOLPAG
         WHERE CDFILIAL    = @V_BOLETPAG_BX_CDFILIAL AND
               NRLANBOLPAG = @V_BOLETPAG_BX_NRLANBOLPAG;

         DECLARE C_CNTPAG_BX CURSOR FOR
            SELECT CDFILIAL,     NRLANCTONF,  NRSEQVENPAG,
                   CDFILIBPAG,   NRLANBOLPAG, CDEMPRESA,
                   CDFIMOVFLPAG, DTMOVFLUXO,  IDMOVFLUXO,
                   CDCLASSFINA,  VRORIGPAG,   NRPARCELAPAG
            FROM CONTAPAGAR
            WHERE CDFILIBPAG   = @V_BOLETPAG_BX_CDFILIAL AND
                  NRLANBOLPAG  = @V_BOLETPAG_BX_NRLANBOLPAG
            ORDER BY NRSEQVENPAG;
         OPEN C_CNTPAG_BX;
         FETCH NEXT FROM C_CNTPAG_BX INTO @V_CNTPAG_BX_CDFILIAL,     @V_CNTPAG_BX_NRLANCTONF,  @V_CNTPAG_BX_NRSEQVENPAG,
                                          @V_CNTPAG_BX_CDFILIBPAG,   @V_CNTPAG_BX_NRLANBOLPAG, @V_CNTPAG_BX_CDEMPRESA,
                                          @V_CNTPAG_BX_CDFIMOVFLPAG, @V_CNTPAG_BX_DTMOVFLUXO,  @V_CNTPAG_BX_IDMOVFLUXO,
                                          @V_CNTPAG_BX_CDCLASSFINA,  @V_CNTPAG_BX_VRORIGPAG,   @V_CNTPAG_BX_NRPARCELAPAG;

         WHILE (@@FETCH_STATUS = 0) BEGIN
            DECLARE C_AJCTPAG_A CURSOR FOR
               SELECT AJ.CDFILIAL,    AJ.NRLANCTONF,   AJ.CDAJUCTPAG,
                      AJ.CDCLASSFINA, AJ.CDEMMFAJCNTP, AJ.CDFIMFAJCNTP,
                      AJ.DTMOVFLUXO,  AJ.IDMOVFLUXO,   AJ.VRAJUSTEPAG,
                      TA.IDAJUCTPAG,  AJ.NRSEQVENPAG,  AJ.NRPARCELAPAG
               FROM AJCTPAGAR AJ, TIPOAJPAGAR TA
               WHERE (AJ.CDFILIAL     = @V_CNTPAG_BX_CDFILIAL)     AND
                     (AJ.NRLANCTONF   = @V_CNTPAG_BX_NRLANCTONF)   AND
                     (AJ.NRSEQVENPAG  = @V_CNTPAG_BX_NRSEQVENPAG)  AND
                     (AJ.NRPARCELAPAG = @V_CNTPAG_BX_NRPARCELAPAG) AND
                     (TA.CDAJUCTPAG   = AJ.CDAJUCTPAG);
            OPEN C_AJCTPAG_A;

            FETCH NEXT FROM C_AJCTPAG_A INTO @V_AJCTPAG_A_CDFILIAL,    @V_AJCTPAG_A_NRLANCTONF,   @V_AJCTPAG_A_CDAJUCTPAG,
                                             @V_AJCTPAG_A_CDCLASSFINA, @V_AJCTPAG_A_CDEMMFAJCNTP, @V_AJCTPAG_A_CDFIMFAJCNTP,
                                             @V_AJCTPAG_A_DTMOVFLUXO,  @V_AJCTPAG_A_IDMOVFLUXO,   @V_AJCTPAG_A_VRAJUSTEPAG,
                                             @V_AJCTPAG_A_IDAJUCTPAG,  @V_AJCTPAG_A_NRSEQVENPAG,  @V_AJCTPAG_A_NRPARCELAPAG;

            WHILE (@@FETCH_STATUS = 0) BEGIN
               IF (@V_AJCTPAG_A_IDAJUCTPAG = 'D') BEGIN
                  SET @V_VRAJUCTPAG = ROUND(@V_AJCTPAG_A_VRAJUSTEPAG, 2);
               END
               ELSE BEGIN
                  SET @V_VRAJUCTPAG = ROUND(@V_AJCTPAG_A_VRAJUSTEPAG * -1, 2);
               END;
               /* - DESFAZ O FLUXO DE CAIXA -------------------------- */
               EXEC ATUALIZA_FLUXO_DE_CAIXA @V_AJCTPAG_A_CDEMMFAJCNTP,
                                            @V_AJCTPAG_A_CDFIMFAJCNTP,
                                            @V_AJCTPAG_A_DTMOVFLUXO,
                                            @V_AJCTPAG_A_IDMOVFLUXO,
                                            @V_AJCTPAG_A_CDCLASSFINA,
                                            0,
                                            @V_VRAJUCTPAG;

               DELETE FROM AJCTPAGAR
               WHERE
                  (CDFILIAL     = @V_AJCTPAG_A_CDFILIAL)     AND
                  (NRLANCTONF   = @V_AJCTPAG_A_NRLANCTONF)   AND
                  (NRSEQVENPAG  = @V_AJCTPAG_A_NRSEQVENPAG)  AND
                  (NRPARCELAPAG = @V_AJCTPAG_A_NRPARCELAPAG);

               FETCH NEXT FROM C_AJCTPAG_A INTO @V_AJCTPAG_A_CDFILIAL,    @V_AJCTPAG_A_NRLANCTONF,   @V_AJCTPAG_A_CDAJUCTPAG,
                                                @V_AJCTPAG_A_CDCLASSFINA, @V_AJCTPAG_A_CDEMMFAJCNTP, @V_AJCTPAG_A_CDFIMFAJCNTP,
                                                @V_AJCTPAG_A_DTMOVFLUXO,  @V_AJCTPAG_A_IDMOVFLUXO,   @V_AJCTPAG_A_VRAJUSTEPAG,
                                                @V_AJCTPAG_A_IDAJUCTPAG,  @V_AJCTPAG_A_NRSEQVENPAG,  @V_AJCTPAG_A_NRPARCELAPAG;
            END;
            CLOSE C_AJCTPAG_A;
            DEALLOCATE C_AJCTPAG_A;

            SET @V_VRORIGPAG = @V_CNTPAG_BX_VRORIGPAG * (-1);
            /* - DESFAZ O FLUXO DE CAIXA -------------------------- */
            EXEC ATUALIZA_FLUXO_DE_CAIXA @V_CNTPAG_BX_CDEMPRESA,
                                         @V_CNTPAG_BX_CDFIMOVFLPAG,
                                         @V_CNTPAG_BX_DTMOVFLUXO,
                                         @V_CNTPAG_BX_IDMOVFLUXO,
                                         @V_CNTPAG_BX_CDCLASSFINA,
                                         0,
                                         @V_VRORIGPAG;

            DELETE FROM CONTAPAGAR
            WHERE (CDFILIAL     = @V_CNTPAG_BX_CDFILIAL)     AND
                  (NRLANCTONF   = @V_CNTPAG_BX_NRLANCTONF)   AND
                  (NRSEQVENPAG  = @V_CNTPAG_BX_NRSEQVENPAG)  AND
                  (NRPARCELAPAG = @V_CNTPAG_BX_NRPARCELAPAG);

            FETCH NEXT FROM C_CNTPAG_BX INTO @V_CNTPAG_BX_CDFILIAL,     @V_CNTPAG_BX_NRLANCTONF,  @V_CNTPAG_BX_NRSEQVENPAG,
                                             @V_CNTPAG_BX_CDFILIBPAG,   @V_CNTPAG_BX_NRLANBOLPAG, @V_CNTPAG_BX_CDEMPRESA,
                                             @V_CNTPAG_BX_CDFIMOVFLPAG, @V_CNTPAG_BX_DTMOVFLUXO,  @V_CNTPAG_BX_IDMOVFLUXO,
                                             @V_CNTPAG_BX_CDCLASSFINA,  @V_CNTPAG_BX_VRORIGPAG,   @V_CNTPAG_BX_NRPARCELAPAG;
         END;
         CLOSE C_CNTPAG_BX;
         DEALLOCATE C_CNTPAG_BX;


         DELETE FROM BOLETPAGAR
         WHERE CDFILIAL    = @V_BOLETPAG_BX_CDFILIAL AND
               NRLANBOLPAG = @V_BOLETPAG_BX_NRLANBOLPAG;

         FETCH NEXT FROM C_BOLETPAG_BX INTO @V_BOLETPAG_BX_CDFILIAL,     @V_BOLETPAG_BX_NRLANBOLPAG,
                                            @V_BOLETPAG_BX_CDFILIBAIPAG, @V_BOLETPAG_BX_NRBAIXAPAG;
      END;
      CLOSE C_BOLETPAG_BX;
      DEALLOCATE C_BOLETPAG_BX;

      SELECT
         @V_CDREDUBX  = MAX(BX.CDREDUCONT),
         @V_NRMOVBANC = MAX(BX.NRMOVBANC),
         @V_CTDEL     = COUNT(*)
      FROM BAIXAPAGA BX
      WHERE
         (BX.CDFILIAL   = @V_CDFILIBAIPAG) AND
         (BX.NRBAIXAPAG = @V_NRBAIXAPAG);

      SET @V_CDSEQUEXBA   = '';
      SET @V_NRSEQMOVREBA = '';
      IF NOT @V_NRMOVBANC IS NULL BEGIN
         SELECT
            @V_CDSEQUEXBA   = MAX(CDSEQUEXBA),
            @V_NRSEQMOVREBA = MAX(NRSEQMOVREBA)
         FROM MOVBANCARIO
         WHERE
            (CDREDUCONT = @V_CDREDUBX) AND
            (NRMOVBANC  = @V_NRMOVBANC);
      END;

      IF @V_CTDEL > 0 BEGIN
         DELETE FROM BAIXAPAGA
         WHERE
            (CDFILIAL   = @V_BOLETPAG_BX_CDFILIBAIPAG) AND
            (NRBAIXAPAG = @V_BOLETPAG_BX_NRBAIXAPAG);
      END;

      IF NOT @V_CDSEQUEXBA IS NULL BEGIN
         UPDATE MOVBANCARIO
         SET
            IDSTCONEXT   = 0,
            IDCONCBANC   = NULL,
            CDSEQUEXBA   = NULL,
            NRSEQMOVREBA = NULL
         WHERE
            (CDREDUCONT   = @V_CDREDUBX)   AND
            (IDSTCONEXT   = '1')          AND
            (CDSEQUEXBA   = @V_CDSEQUEXBA) AND
            (NRSEQMOVREBA = @V_NRSEQMOVREBA);
      END;

      IF NOT @V_NRMOVBANC IS NULL BEGIN
         DELETE FROM MOVBANCARIO
         WHERE
            (CDREDUCONT = @V_CDREDUBX) AND
            (NRMOVBANC  = @V_NRMOVBANC);
      END;

      IF NOT @V_CDSEQUEXBA IS NULL BEGIN
         UPDATE MOVREAL
         SET
            IDSTCONMVBAN = 0,
            IDCONCREAL   = NULL,
            NRMOVBARE    = NULL
         WHERE
            (CDREDUCONT   = @V_CDREDUBX) AND
            (CDSEQUEXTR   = @V_CDSEQUEXBA) AND
            (NRSEQMOVREAL = @V_NRSEQMOVREBA);
      END;

      /* BUSCA TODAS OS BOLETOS QUE NO ESTO LIGADOS A BAIXA  */
      DECLARE C_BOLETPAG_AB CURSOR FOR
         SELECT CDFILIAL,     NRLANCTONF,  NRSEQVENPAG,
                CDFILIBPAG,   NRLANBOLPAG, CDEMPRESA,
                CDFIMOVFLPAG, DTMOVFLUXO,  IDMOVFLUXO,
                CDCLASSFINA,  VRORIGPAG,   NRPARCELAPAG
         FROM CONTAPAGAR
         WHERE (CDFILIBPAG   = @V_CNTPAG_CDFILIBPAG) AND
               (NRLANBOLPAG  = @V_CNTPAG_NRLANBOLPAG)
         ORDER BY NRSEQVENPAG;
      OPEN C_BOLETPAG_AB;
      FETCH NEXT FROM C_BOLETPAG_AB INTO @V_BOLETPAG_AB_CDFILIAL,     @V_BOLETPAG_AB_NRLANCTONF,  @V_BOLETPAG_AB_NRSEQVENPAG,
                                         @V_BOLETPAG_AB_CDFILIBPAG,   @V_BOLETPAG_AB_NRLANBOLPAG, @V_BOLETPAG_AB_CDEMPRESA,
                                         @V_BOLETPAG_AB_CDFIMOVFLPAG, @V_BOLETPAG_AB_DTMOVFLUXO,  @V_BOLETPAG_AB_IDMOVFLUXO,
                                         @V_BOLETPAG_AB_CDCLASSFINA,  @V_BOLETPAG_AB_VRORIGPAG,   @V_BOLETPAG_AB_NRPARCELAPAG
      WHILE (@@FETCH_STATUS = 0) BEGIN

         DECLARE C_RATR_B CURSOR FOR
            SELECT AJ.CDFILIAL,     AJ.NRLANBOLPAG, AJ.CDAJUCTPAG,
                   AJ.VRAJBOLPAG,   CR.CDCLASSFINA, CR.CDEMPRESA,
                   CR.CDFIMOVFLPAG, CR.DTMOVFLUXO,  CR.IDMOVFLUXO,
                   TA.IDAJUCTPAG,   CR.IDSTATPAG,
                   (CASE MAX(BR.VRBOLPAG) WHEN 0
                    THEN 0
                    ELSE (MAX(AJ.VRAJBOLPAG) * SUM(CR.VRATUAPAG))/ MAX(BR.VRBOLPAG) END) VRRATAJBOLPAG
            FROM CONTAPAGAR  CR, BOLETPAGAR BR,
                 TIPOAJPAGAR TA, AJBOLPAG   AJ
            WHERE (AJ.CDFILIAL     = @V_BOLETPAG_AB_CDFILIBPAG)    AND
                  (AJ.NRLANBOLPAG  = @V_BOLETPAG_AB_NRLANBOLPAG) AND
                  (TA.CDAJUCTPAG   = AJ.CDAJUCTPAG)        AND
                  (BR.CDFILIAL     = AJ.CDFILIAL)          AND
                  (BR.NRLANBOLPAG  = AJ.NRLANBOLPAG)       AND
                  (CR.CDFILIBPAG   = BR.CDFILIAL)          AND
                  (CR.NRLANBOLPAG  = BR.NRLANBOLPAG)
            GROUP BY
               AJ.CDFILIAL,     AJ.NRLANBOLPAG, AJ.CDAJUCTPAG,
               AJ.VRAJBOLPAG,   CR.CDCLASSFINA, CR.CDEMPRESA,
               CR.CDFIMOVFLPAG, CR.DTMOVFLUXO,  CR.IDMOVFLUXO,
               TA.IDAJUCTPAG,   CR.IDSTATPAG;
         OPEN C_RATR_B;
         FETCH NEXT FROM C_RATR_B INTO @V_RATR_B_CDFILIAL,     @V_RATR_B_NRLANBOLPAG, @V_RATR_B_CDAJUCTPAG,
                                       @V_RATR_B_VRAJBOLPAG,   @V_RATR_B_CDCLASSFINA, @V_RATR_B_CDEMPRESA,
                                       @V_RATR_B_CDFIMOVFLPAG, @V_RATR_B_DTMOVFLUXO,  @V_RATR_B_IDMOVFLUXO,
                                       @V_RATR_B_IDAJUCTPAG,   @V_RATR_B_IDSTATPAG,   @V_RATR_B_VRRATAJBOLPAG;
         WHILE (@@FETCH_STATUS = 0) BEGIN

            IF (@V_RATR_B_IDAJUCTPAG = 'D') BEGIN
               SET @V_VRAJBOLPAG = ROUND(@V_RATR_B_VRRATAJBOLPAG, 2);
            END
            ELSE BEGIN
               SET @V_VRAJBOLPAG = ROUND(@V_RATR_B_VRRATAJBOLPAG * -1, 2);
            END;
            /* - DESFAZ O FLUXO DE CAIXA -------------------------- */
            EXEC ATUALIZA_FLUXO_DE_CAIXA @V_RATR_B_CDEMPRESA,
                                         @V_RATR_B_CDFIMOVFLPAG,
                                         @V_RATR_B_DTMOVFLUXO,
                                         @V_RATR_B_IDMOVFLUXO,
                                         @V_RATR_B_CDCLASSFINA,
                                         0,
                                         @V_VRAJBOLPAG;

            DELETE FROM MOVFXAJBOLP
            WHERE CDFILIBOLPAG = @V_BOLETPAG_AB_CDFILIBPAG AND
                  NRLANBOLPAG  = @V_BOLETPAG_AB_NRLANBOLPAG  AND
                  CDAJUCTPAG   = @V_RATR_B_CDAJUCTPAG;

            FETCH NEXT FROM C_RATR_B INTO @V_RATR_B_CDFILIAL,     @V_RATR_B_NRLANBOLPAG, @V_RATR_B_CDAJUCTPAG,
                                          @V_RATR_B_VRAJBOLPAG,   @V_RATR_B_CDCLASSFINA, @V_RATR_B_CDEMPRESA,
                                          @V_RATR_B_CDFIMOVFLPAG, @V_RATR_B_DTMOVFLUXO,  @V_RATR_B_IDMOVFLUXO,
                                          @V_RATR_B_IDAJUCTPAG,   @V_RATR_B_IDSTATPAG,   @V_RATR_B_VRRATAJBOLPAG;
         END;
         CLOSE C_RATR_B;
         DEALLOCATE C_RATR_B;

         DECLARE C_AJCTPAG_B CURSOR FOR
            SELECT AJ.CDFILIAL,    AJ.NRLANCTONF,   AJ.CDAJUCTPAG,
                   AJ.CDCLASSFINA, AJ.CDEMMFAJCNTP, AJ.CDFIMFAJCNTP,
                   AJ.DTMOVFLUXO,  AJ.IDMOVFLUXO,   AJ.VRAJUSTEPAG,
                   TA.IDAJUCTPAG,  AJ.NRSEQVENPAG,  AJ.NRPARCELAPAG
            FROM AJCTPAGAR AJ, TIPOAJPAGAR TA
            WHERE (AJ.CDFILIAL     = @V_BOLETPAG_AB_CDFILIAL)     AND
                  (AJ.NRLANCTONF   = @V_BOLETPAG_AB_NRLANCTONF)   AND
                  (AJ.NRSEQVENPAG  = @V_BOLETPAG_AB_NRSEQVENPAG)  AND
                  (AJ.NRPARCELAPAG = @V_BOLETPAG_AB_NRPARCELAPAG) AND
                  (TA.CDAJUCTPAG   = AJ.CDAJUCTPAG);
         OPEN C_AJCTPAG_B;
         FETCH NEXT FROM C_AJCTPAG_B INTO @V_AJCTPAG_B_CDFILIAL,    @V_AJCTPAG_B_NRLANCTONF,   @V_AJCTPAG_B_CDAJUCTPAG,
                                          @V_AJCTPAG_B_CDCLASSFINA, @V_AJCTPAG_B_CDEMMFAJCNTP, @V_AJCTPAG_B_CDFIMFAJCNTP,
                                          @V_AJCTPAG_B_DTMOVFLUXO,  @V_AJCTPAG_B_IDMOVFLUXO,   @V_AJCTPAG_B_VRAJUSTEPAG,
                                          @V_AJCTPAG_B_IDAJUCTPAG,  @V_AJCTPAG_B_NRSEQVENPAG,  @V_AJCTPAG_B_NRPARCELAPAG;

         WHILE (@@FETCH_STATUS = 0) BEGIN

            IF (@V_AJCTPAG_B_IDAJUCTPAG = 'D') BEGIN
               SET @V_VRAJUCTPAG = ROUND(@V_AJCTPAG_B_VRAJUSTEPAG, 2);
            END
            ELSE BEGIN
               SET @V_VRAJUCTPAG = ROUND(@V_AJCTPAG_B_VRAJUSTEPAG * -1, 2);
            END;
            /* - DESFAZ O FLUXO DE CAIXA -------------------------- */
            EXEC ATUALIZA_FLUXO_DE_CAIXA @V_AJCTPAG_B_CDEMMFAJCNTP,
                                         @V_AJCTPAG_B_CDFIMFAJCNTP,
                                         @V_AJCTPAG_B_DTMOVFLUXO,
                                         @V_AJCTPAG_B_IDMOVFLUXO,
                                         @V_AJCTPAG_B_CDCLASSFINA,
                                         0,
                                         @V_VRAJUCTPAG;

            DELETE FROM AJCTPAGAR
            WHERE
               (CDFILIAL     = @V_AJCTPAG_B_CDFILIAL)     AND
               (NRLANCTONF   = @V_AJCTPAG_B_NRLANCTONF)   AND
               (NRSEQVENPAG  = @V_AJCTPAG_B_NRSEQVENPAG)  AND
               (NRPARCELAPAG = @V_AJCTPAG_B_NRPARCELAPAG);

            FETCH NEXT FROM C_AJCTPAG_B INTO @V_AJCTPAG_B_CDFILIAL,    @V_AJCTPAG_B_NRLANCTONF,   @V_AJCTPAG_B_CDAJUCTPAG,
                                             @V_AJCTPAG_B_CDCLASSFINA, @V_AJCTPAG_B_CDEMMFAJCNTP, @V_AJCTPAG_B_CDFIMFAJCNTP,
                                             @V_AJCTPAG_B_DTMOVFLUXO,  @V_AJCTPAG_B_IDMOVFLUXO,   @V_AJCTPAG_B_VRAJUSTEPAG,
                                             @V_AJCTPAG_B_IDAJUCTPAG,  @V_AJCTPAG_B_NRSEQVENPAG,  @V_AJCTPAG_B_NRPARCELAPAG;
         END;
         CLOSE C_AJCTPAG_B;
         DEALLOCATE C_AJCTPAG_B;

         SET @V_VRORIGPAG = @V_BOLETPAG_AB_VRORIGPAG * (-1);
         /* - DESFAZ O FLUXO DE CAIXA -------------------------- */
         EXEC ATUALIZA_FLUXO_DE_CAIXA @V_BOLETPAG_AB_CDEMPRESA,
                                      @V_BOLETPAG_AB_CDFIMOVFLPAG,
                                      @V_BOLETPAG_AB_DTMOVFLUXO,
                                      @V_BOLETPAG_AB_IDMOVFLUXO,
                                      @V_BOLETPAG_AB_CDCLASSFINA,
                                      0,
                                      @V_VRORIGPAG;

         DELETE FROM CONTAPAGAR
         WHERE CDFILIBPAG  = @V_BOLETPAG_AB_CDFILIBPAG AND
               NRLANBOLPAG = @V_BOLETPAG_AB_NRLANBOLPAG;

         FETCH NEXT FROM C_BOLETPAG_AB INTO @V_BOLETPAG_AB_CDFILIAL,     @V_BOLETPAG_AB_NRLANCTONF,  @V_BOLETPAG_AB_NRSEQVENPAG,
                                            @V_BOLETPAG_AB_CDFILIBPAG,   @V_BOLETPAG_AB_NRLANBOLPAG, @V_BOLETPAG_AB_CDEMPRESA,
                                            @V_BOLETPAG_AB_CDFIMOVFLPAG, @V_BOLETPAG_AB_DTMOVFLUXO,  @V_BOLETPAG_AB_IDMOVFLUXO,
                                            @V_BOLETPAG_AB_CDCLASSFINA,  @V_BOLETPAG_AB_VRORIGPAG,   @V_BOLETPAG_AB_NRPARCELAPAG
      END;
      CLOSE C_BOLETPAG_AB;
      DEALLOCATE C_BOLETPAG_AB;

      DELETE FROM AJBOLPAG
      WHERE CDFILIAL    = @V_CNTPAG_CDFILIBPAG AND
            NRLANBOLPAG = @V_CNTPAG_NRLANBOLPAG;

      DELETE FROM BOLETPAGAR
      WHERE CDFILIAL    = @V_CNTPAG_CDFILIBPAG AND
            NRLANBOLPAG = @V_CNTPAG_NRLANBOLPAG;

      FETCH NEXT FROM C_CNTPAG INTO @V_CNTPAG_CDFILIAL,    @V_CNTPAG_NRLANCTONF,   @V_CNTPAG_NRSEQVENPAG,
                                    @V_CNTPAG_VRATUAPAG,   @V_CNTPAG_CDFILIBPAG,   @V_CNTPAG_NRLANBOLPAG,
                                    @V_CNTPAG_CDEMPRESA,   @V_CNTPAG_CDFIMOVFLPAG, @V_CNTPAG_DTMOVFLUXO,
                                    @V_CNTPAG_IDMOVFLUXO,  @V_CNTPAG_CDCLASSFINA,  @V_CNTPAG_VRORIGPAG,
                                    @V_CNTPAG_NRPARCELAPAG;
   END;
   CLOSE C_CNTPAG;
   DEALLOCATE C_CNTPAG;
END;
GO
